/*
$Id: LR260_V1/smha__lr2601.ddl 1.30.1.2 2007/12/17 15:06:26EST Daigle, Frank (Frank Daigle) Dev  $
$ProjectName: d:/elect/source/device_descriptions/pdm/hart/hart_sensor_level_milltronics_lr260/hart_sensor_level_milltronics_lr260.pj $   $Locker:  $
*/

/*                                                       For Internal Use Only.
   Description: ----------------------------------------------------------------
       Main DD File.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------
*/

MANUFACTURER 88, DEVICE_TYPE 0xD4, DEVICE_REVISION 2, DD_REVISION 2

/* Defines --------------------------------------------------------------------*/
#define DD_VERSION "1.00.05"
#define FIRMWARE_REVISION "1.00.02"
#define DEVICE_MANUAL_FILENAME "lr260_user_manual_ha_en.pdf|de|lr260_user_manual_ha_de.pdf"
#define DEVICE_ORDER_NUMBER "7ML5427-0xxx0-0xxx"
#define DEVICE_TYPE_ID 0xD4
#define DEVICE_TYPE_NAME "SITRANS LR260"
#define DEVICE_TYPE_DESCRIPTION "HART Echo Field Device Sitrans LR260"
#define DEVICE_TYPE_WEB_SITE "www.siemens-milltronics.com"
#define DEVICE_TYPE_MANUFACTURER_ID 88
#define DEVICE_TYPE_MANUFACTURER "Siemens Milltronics"

#define DEVICE_MAX_RANGE_METERS 30.0

#define TB_RANGE_HI_MAX         31.5
#define TB_RANGE_HI_OFFSET      3.0

/* ********** Provide compatability between PDM versions *********** */
#define GENERATE_602_HELP 0    /* Set to 1 when using this dd under 5.2 to generate help for 6.0 */
//#define DD_MEANT_FOR_PDM52   /* Define this to force the dd to behave like 5.2 when running under 6.0 */
#include "compatability.inc"   /* Defines to provide compatability between PDM versions */
/* ***** Compatability tests can be performed after this point ***** */

#define MIN_FLOAT -99999
#define MAX_FLOAT  99999
#define SECONDS_PER_YEAR 31558464    /* 365.26 days, same as device */
#define SECONDS_PER_HOUR 3600
#define SECONDS_PER_DAY 86400
#define MAX_LIFETIME_SECONDS SECONDS_PER_YEAR * 20     // 631,169,280 seconds in 20 years

#define FEET_UNITS                       44 
#define METER_UNITS                      45 
#define INCH_UNITS                       47 
#define CENTIMETER_UNITS                 48 
#define MILLIMETER_UNITS                 49 
#define PERCENT_UNITS                   251

#define LINEAL_DISPLAY_FORMAT                  \
   SELECT (trans1_sensor_unit)                 \
      {                                        \
      CASE FEET_UNITS:       ".2f"; /* ft */   \
      CASE METER_UNITS:      ".3f"; /* meter */\
      CASE INCH_UNITS:       ".1f"; /* in */   \
      CASE CENTIMETER_UNITS: ".1f"; /* cm */   \
      CASE MILLIMETER_UNITS: ".f";  /* mm */   \
      DEFAULT:               ".3f";            \
      }

#define LINEAL_EDIT_FORMAT                       \
   SELECT (trans1_sensor_unit)                   \
      {                                          \
      CASE  FEET_UNITS:       "6.2f"; /* ft */   \
      CASE  METER_UNITS:      "6.3f"; /* meter */\
      CASE  INCH_UNITS:       "6.1f"; /* in */   \
      CASE  CENTIMETER_UNITS: "6.1f"; /* cm */   \
      CASE  MILLIMETER_UNITS: "5.f";  /* mm */   \
      DEFAULT:                "6.3f";            \
      }

#define METER_TO_CENTIMETER    1.0E2
#define METER_TO_MILLIMETER    1.0E3
#define METER_TO_FEET          (1/0.3048) /* This value matches the device */
#define METER_TO_INCH          (1/0.0254) /* This value matches the device */

#define MACRO_LINEAL_CONVERSION(units, scale)                     \
   switch (units)                                                 \
      {                                                           \
      case FEET_UNITS:       scale = METER_TO_FEET;       break;  \
      case METER_UNITS:      scale = 1;                   break;  \
      case INCH_UNITS:       scale = METER_TO_INCH;       break;  \
      case CENTIMETER_UNITS: scale = METER_TO_CENTIMETER; break;  \
      case MILLIMETER_UNITS: scale = METER_TO_MILLIMETER; break;  \
      }

#define MACRO_MAX_VALUE(max_value)                            \
   SELECT (trans1_sensor_unit)                                \
   {                                                          \
      CASE FEET_UNITS:       max_value * METER_TO_FEET;       \
      CASE METER_UNITS:      max_value;                       \
      CASE INCH_UNITS:       max_value * METER_TO_INCH;       \
      CASE CENTIMETER_UNITS: max_value * METER_TO_CENTIMETER; \
      CASE MILLIMETER_UNITS: max_value * METER_TO_MILLIMETER; \
   }

#define MACRO_FAR_RANGE_DEFAULT (trans1_cal_point_lo + MACRO_MAX_VALUE(TB_RANGE_HI_OFFSET))

#define MACRO_PV_MAX_VALUE(max_value)                                                \
   SELECT (par_pv_units)                                                             \
   {                                                                                 \
      CASE FEET_UNITS:       max_value * METER_TO_FEET;                              \
      CASE METER_UNITS:      max_value;                                              \
      CASE INCH_UNITS:       max_value * METER_TO_INCH;                              \
      CASE CENTIMETER_UNITS: max_value * METER_TO_CENTIMETER;                        \
      CASE MILLIMETER_UNITS: max_value * METER_TO_MILLIMETER;                        \
      CASE PERCENT_UNITS:    par_max_volume * (max_value / DEVICE_MAX_RANGE_METERS); \
   }

/* Defines for operation enumeration */
#define  OPERATION_APP_OFF        0
#define  OPERATION_APP_MATL       1
#define  OPERATION_APP_SPACE      2
#define  OPERATION_APP_DIST       3

/* Defines for substance enumeration */
#define  SUBSTANCE_MATERIAL_LIQUID        1
#define  SUBSTANCE_MATERIAL_SOLID         2
#define  SUBSTANCE_MATERIAL_LIQUID_LOWDK  3

/* Defines for response rate enumeration */
#define  RESPONSE_SLOW     1
#define  RESPONSE_MEDIUM   2
#define  RESPONSE_FAST     3
#define  RESPONSE_SURGE    4
#define  RESPONSE_TURBO    5

/* Defines for antenna type enumeration */
#define  TRANSDUCER_MWAVE_NO_HORN    300
#define  TRANSDUCER_MWAVE_2IN_HORN   301
#define  TRANSDUCER_MWAVE_3IN_HORN   302
#define  TRANSDUCER_MWAVE_4IN_HORN   303

/* Defines for blanking_default */
#define  BLANKING_MWAVE_HORN_SIZE2 0.214
#define  BLANKING_MWAVE_HORN_SIZE3 0.278
#define  BLANKING_MWAVE_HORN_SIZE4 0.335

#define MACRO_BLANKING_DEFAULT                                                     \
   SELECT (par_tb_transducer)                                                      \
   {                                                                               \
      CASE TRANSDUCER_MWAVE_2IN_HORN : MACRO_MAX_VALUE(BLANKING_MWAVE_HORN_SIZE2); \
      CASE TRANSDUCER_MWAVE_3IN_HORN : MACRO_MAX_VALUE(BLANKING_MWAVE_HORN_SIZE3); \
      CASE TRANSDUCER_MWAVE_4IN_HORN : MACRO_MAX_VALUE(BLANKING_MWAVE_HORN_SIZE4); \
      CASE TRANSDUCER_MWAVE_NO_HORN  : MACRO_MAX_VALUE(BLANKING_MWAVE_HORN_SIZE3); \
   }

/* Defines for cal low default */
#define  CAL_LO_DEFAULT_MWAVE_HORN_SIZE2 10
#define  CAL_LO_DEFAULT_MWAVE_HORN_SIZE3 20
#define  CAL_LO_DEFAULT_MWAVE_HORN_SIZE4 30

#define MACRO_CAL_LO_DEFAULT                                                             \
   SELECT (par_tb_transducer)                                                            \
   {                                                                                     \
      CASE TRANSDUCER_MWAVE_2IN_HORN : MACRO_MAX_VALUE(CAL_LO_DEFAULT_MWAVE_HORN_SIZE2); \
      CASE TRANSDUCER_MWAVE_3IN_HORN : MACRO_MAX_VALUE(CAL_LO_DEFAULT_MWAVE_HORN_SIZE3); \
      CASE TRANSDUCER_MWAVE_4IN_HORN : MACRO_MAX_VALUE(CAL_LO_DEFAULT_MWAVE_HORN_SIZE4); \
      CASE TRANSDUCER_MWAVE_NO_HORN  : MACRO_MAX_VALUE(CAL_LO_DEFAULT_MWAVE_HORN_SIZE3); \
   }

#define MACRO_SAMPLING_DOWN_DEFAULT \
   SELECT (par_echo_lock)           \
   {                                \
      CASE 0: 5;                    \
      CASE 1: 5;                    \
      CASE 2: 2;                    \
      CASE 3: 5;                    \
   }

#define MACRO_RATE_LIMIT_DEFAULT                     \
   SELECT (par_tb_response_rate)                     \
   {                                                 \
      CASE RESPONSE_SLOW:   MACRO_MAX_VALUE(   0.1); \
      CASE RESPONSE_MEDIUM: MACRO_MAX_VALUE(   1.0); \
      CASE RESPONSE_FAST:   MACRO_MAX_VALUE(  10.0); \
      CASE RESPONSE_SURGE:  MACRO_MAX_VALUE( 100.0); \
      CASE RESPONSE_TURBO:  MACRO_MAX_VALUE(1000.0); \
   }

#define MACRO_FAIL_SAFE_TIMER_DEFAULT \
   SELECT (par_tb_response_rate)      \
   {                                  \
      CASE RESPONSE_SLOW:    100.0;   \
      CASE RESPONSE_MEDIUM:   10.0;   \
      CASE RESPONSE_FAST:      1.0;   \
      CASE RESPONSE_SURGE:     0.1;   \
      CASE RESPONSE_TURBO:     0.0;   \
   }
#define MACRO_FOLF_TIME_CONSTANT_DEFAULT \
   SELECT (par_tb_response_rate)         \
   {                                     \
      CASE RESPONSE_SLOW:     60.0;      \
      CASE RESPONSE_MEDIUM:   10.0;      \
      CASE RESPONSE_FAST:      0.0;      \
      CASE RESPONSE_SURGE:     0.0;      \
      CASE RESPONSE_TURBO:     0.0;      \
   }

/* Defines for tank shape enumeration */
#define TANK_SHAPE_NON_VOLUME                0
#define TANK_SHAPE_FLAT_BOTTOM               1
#define TANK_SHAPE_CONIC_BOTTOM              2
#define TANK_SHAPE_PARABOLIC_BOTTOM          3
#define TANK_SHAPE_HALF_SPHERE_BOTTOM        4
#define TANK_SHAPE_FLAT_SLOPE_BOTTOM         5
#define TANK_SHAPE_HORIZ_CYLINDER_FLAT_ENDS  6
#define TANK_SHAPE_HORIZ_CYLINDER_PARAB_ENDS 7
#define TANK_SHAPE_SPHERE                    8
#define TANK_SHAPE_BKPT_LINEAR               9

/* Defines for algorithm enumeration */
#define  ALGORITHM_ALF   1
#define  ALGORITHM_A     2
#define  ALGORITHM_L     3
#define  ALGORITHM_F     4
#define  ALGORITHM_AL    5
#define  ALGORITHM_AF    6
#define  ALGORITHM_LF    7
#define  ALGORITHM_bLF   8
#define  ALGORITHM_bL    9
#define  ALGORITHM_bF   10
#define  ALGORITHM_LAST 11
#define  ALGORITHM_tF   12

/* Defines for TVT Types */
#define TVT_TYPE_NONE                 0
#define TVT_TYPE_MULTI_SMOOTH         1
#define TVT_TYPE_MULTI_FLAT           2
#define TVT_TYPE_LINEAR_ALL           3
#define TVT_TYPE_LINEAR_HALF          4
#define TVT_TYPE_SMOOTH               5
#define TVT_TYPE_SLOPES               6
#define TVT_TYPE_RADAR_SMOOTH_2       7
#define TVT_TYPE_RADAR_SMOOTH_3       8
#define TVT_TYPE_RADAR_SMOOTH_4       9
#define TVT_TYPE_MULTI_SMOOTH2       10

/* Define the DEFAULT hover levels for each TVT Type */
#define TVT_TYPE_NONE_HOVER            33
#define TVT_TYPE_MULTI_SMOOTH_HOVER    33
#define TVT_TYPE_MULTI_FLAT_HOVER      33
#define TVT_TYPE_LINEAR_ALL_HOVER      33
#define TVT_TYPE_LINEAR_HALF_HOVER     33
#define TVT_TYPE_SMOOTH_HOVER          33
#define TVT_TYPE_RADAR_SMOOTH_2_HOVER  40
#define TVT_TYPE_RADAR_SMOOTH_3_HOVER  40
#define TVT_TYPE_RADAR_SMOOTH_4_HOVER  40

#define MACRO_HOVER_DEFAULT                                         \
   SELECT (par_tb_tvt_type)                                         \
   {                                                                \
      CASE TVT_TYPE_NONE           : TVT_TYPE_NONE_HOVER;           \
      CASE TVT_TYPE_MULTI_SMOOTH   : TVT_TYPE_MULTI_SMOOTH_HOVER;   \
      CASE TVT_TYPE_MULTI_FLAT     : TVT_TYPE_MULTI_FLAT_HOVER;     \
      CASE TVT_TYPE_LINEAR_ALL     : TVT_TYPE_LINEAR_ALL_HOVER;     \
      CASE TVT_TYPE_LINEAR_HALF    : TVT_TYPE_LINEAR_HALF_HOVER;    \
      CASE TVT_TYPE_SMOOTH         : TVT_TYPE_SMOOTH_HOVER;         \
      CASE TVT_TYPE_SLOPES         : TVT_TYPE_NONE_HOVER;           \
      CASE TVT_TYPE_RADAR_SMOOTH_2 : TVT_TYPE_RADAR_SMOOTH_2_HOVER; \
      CASE TVT_TYPE_RADAR_SMOOTH_3 : TVT_TYPE_RADAR_SMOOTH_3_HOVER; \
      CASE TVT_TYPE_RADAR_SMOOTH_4 : TVT_TYPE_RADAR_SMOOTH_4_HOVER; \
      CASE TVT_TYPE_MULTI_SMOOTH2  : TVT_TYPE_MULTI_SMOOTH_HOVER;   \
   }

/* Defines for echo zoom enumeration */
#define TVT_MS_ECHOZOOM_OFF       0
#define TVT_MS_ECHOZOOM_AUTO      1
#define TVT_MS_ECHOZOOM_FIXED     2

/* Defines for echo position enumeration */
#define  ECHO_POSITION_RISING_EDGE        1
#define  ECHO_POSITION_CENTER_OF_MASS     3
#define  ECHO_POSITION_HYBRID_COM_LEF     4
#define  ECHO_POSITION_LEADING_EDGE_FIT   5

/* Defines for master reset enumeration */
#define MASTER_RESET_STATE_IDLE_DONE            0
#define MASTER_RESET_STATE_RESET_PARAMETERS     1
#define MASTER_RESET_STATE_RESET_WEAR_SCHEDULE  2

#ifndef EDDL_SUPPORT   /* for PDM version = 5.2 and Help */
   /* YT diagram*/
   #define YT1_LABEL    [Level_label]
   #define YT1_HELP     [par_tb_level_value_help]
   #define YT1_VALUE    collection_level.DIGITAL_VALUE
   #define YT1_LRV      collection_level.LOWER_RANGE_VALUE
   #define YT1_URV      collection_level.UPPER_RANGE_VALUE
   #define YT2_LABEL    [Distance_label]
   #define YT2_HELP     [par_distance_reading_help]
   #define YT2_VALUE    collection_distance.DIGITAL_VALUE
   #define YT2_LRV      collection_distance.LOWER_RANGE_VALUE
   #define YT2_URV      collection_distance.UPPER_RANGE_VALUE
#endif
#ifndef PDM52_SUPPORT  /* for PDM version >= 6.0 and Help */
   /* Enable data saving */
   #define SAVEECHOPROFILE_INC
   //#define SHOWTREND_INC
#endif

/* Include Files --------------------------------------------------------------*/
/* Standard include files */
#include "bi_codes.h"
#include "macros.ddl"

/***** PDM Standard includes *****/
#include "SIHA.inc"                        /* Standard Hart Includes */
#include "SI_MainMenu.inc"                 /* Standard Menu includes */
#include "SI_FileM.inc"                    /* Standard File Menu */
#include "SI_ViewM.inc"                    /* Standard View Menu */
#include "SI_OptM.inc"                     /* Standard Options Menu */
#include "SI_HlpM.inc"                     /* Standard Help Menu */
#ifdef _V600_
   #include "SI__Global_02.ddl"               /* Diagnostic support */
#else
   #include "SI__Global_01.ddl"               /* Diagnostic support */
#endif

/* Our Standard files */
#include "SoftwareRevision.inc"         /* Convert SW revision string to a number */
#ifndef PDM52_SUPPORT   /* for PDM version >= 6.0 */
   #include "readechoprofile.dd"        /* Commands and parameters for echo profiles */
#endif

/* --- Device menu --- */
#ifndef PDM52_SUPPORT   /* for PDM version >= 6.0 */
   #include "quickstart.dd"             /* Quick setup wizard menu item in Device sub menu */
#endif
#include "autotvt.inc"                  /* Auto TVT menu item in Device sub menu */
#ifndef PDM52_SUPPORT   /* for PDM version >= 6.0 */
   #include "tvtshaper40.inc"           /* Manual TVT menu item in Device sub menu */
#endif
#include "smpi_maintenance.inc"         /* Maintenance dialogs in Device and View|Status */
#include "selftest.dd"                  /* Self Test menu item in Device sub menu */
#include "reset.dd"                     /* Master Reset menu item in Device sub menu */
#include "pv_select.dd"                 /* Analog out selection item in Device sub menu */
#include "ma_trim.dd"                   /* mA trim menu item in Device sub menu */

/* --- View menu --- */
#include "display.dd"                   /* Display window in View sub menu */
#include "im_functions.dd"
#ifndef EDDL_SUPPORT   /* for PDM version = 5.2 and Help */
   #include "SI_YT.inc"                 /* To draw YT diagram */
   #include "echoprofile_V5_2.dd"       /* Echo profile dialog in View sub menu */
#endif
#ifndef PDM52_SUPPORT  /* for PDM version >= 6.0 and Help */
   #include "trend.inc"                 /* Trend dialog in View sub menu */
   //#include "showtrend.inc"           /* Show Saved Trend dialog in View sub menu */
   #include "echoprofile.inc"           /* Echo profile dialog in View sub menu */
   #include "saveechoprofile.inc"       /* Show Saved Echo profile dialog in View sub menu */
#endif
#include "diagnostic.dd"                /* Status window item in View sub menu */
#include "wear.dd"                      /* Wear window item in View sub menu */

/* Maintenance and Diagnostic information */
#include "LR260_HA_DeviceDiagnosis.dd"   /* Extended diagnostic information (must be included after diagnostic.dd) */

/* Imports --------------------------------------------------------------------*/
#include "LR260_HA_imports.dd"

/* Collections ----------------------------------------------------------------*/
#include "LR260_HA_collections.dd"

/* Relations ------------------------------------------------------------------*/
#include "LR260_HA_relations.dd"

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Autogenerated variables
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifdef HELP_SUPPORT
   #define par_pb_device_maintenance_ack_label      par_pb_device_maintenance_ack_helpgen_label
   #define par_tb_sensor_maintenance_ack_label      par_tb_sensor_maintenance_ack_helpgen_label
   #define par_tb_service_maintenance_ack_label     par_tb_service_maintenance_ack_helpgen_label
   #define par_pb_calibration_maintenance_ack_label par_pb_calibration_maintenance_ack_helpgen_label
#endif
#include "LR260_HA_parameters.dd"

/*-----------------------------------------------------------------------------
   Description: Information for EDD_HelpGen
   Created by:  Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE DEVICE_TYPE_Name
{
   LABEL "DEVICE_TYPE_Name";
   CLASS LOCAL;
   TYPE ASCII(40)
   {
      DEFAULT_VALUE DEVICE_TYPE_NAME;
   }
}

VARIABLE DEVICE_TYPE_Description
{
   LABEL "DEVICE_TYPE_Description";
   CLASS LOCAL;
   TYPE ASCII(256)
   {
      DEFAULT_VALUE DEVICE_TYPE_DESCRIPTION;
   }
}

VARIABLE DEVICE_TYPE_Manufacturer
{
   LABEL "DEVICE_TYPE Manufacturer";
   CLASS LOCAL;
   TYPE ASCII(40)
   {
      DEFAULT_VALUE DEVICE_TYPE_MANUFACTURER;
   }
}

VARIABLE DEVICE_TYPE_ContactWebsite
{
   LABEL "DEVICE_TYPE Website";
   CLASS LOCAL;
   TYPE ASCII(40)
   {
      DEFAULT_VALUE DEVICE_TYPE_WEB_SITE;
   }
}

VARIABLE DEVICE_Order_Number
{
   LABEL [device_mlfb_number_label];
   HELP  [device_mlfb_number_help];
   CLASS DEVICE;
   TYPE  ASCII (22)
   {
      DEFAULT_VALUE DEVICE_ORDER_NUMBER;
   }
   HANDLING READ;
   #ifdef EDDL_SUPPORT
      PURPOSE  "Device.Type.Ident.OrderNumber";
   #endif
   POST_READ_ACTIONS
   {
       method_post_read_actions_device_order_number
   }
}

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE phys_device_certification
{
   LABEL    [phys_device_certification_label];
   HELP     [phys_device_certification_help];
   CLASS    LOCAL;
   TYPE     ASCII (32)
   {
      DEFAULT_VALUE [phys_device_certification_default_label];
   }
   HANDLING READ;
}

/*-----------------------------------------------------------------------------
   Description: Information for EDD_HelpGen
   Created by: Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE phys_device_description_local
{
   LABEL [phys_device_description_local_label];
   HELP [phys_device_description_local_help];
   CLASS LOCAL;
   TYPE ASCII(12)
   {
      DEFAULT_VALUE DD_VERSION;
   }
   PRE_EDIT_ACTIONS
   {
      method_preedit_dd_rev, method_calculate_software_revision
   }
}

/*-----------------------------------------------------------------------------
   Description: Variable related with DEVICE_Order_Number
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_image_switch
{
   #ifdef HELP_SUPPORT
      LABEL [device_mlfb_number_label];
      HELP  [device_mlfb_number_help];
   #endif
    CLASS       LOCAL;
    TYPE        UNSIGNED_INTEGER(1);
}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Autogenerated commands
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#include "LR260_HA_commands.dd"

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
COMMAND read_Order_Number
{
   NUMBER 238;
   OPERATION READ;
   TRANSACTION
   {
      REQUEST
      {
         1
      }
      REPLY
      {
         response_code, device_status, DEVICE_Order_Number
       }
   }
   RESPONSE_CODES
   {
      0,  SUCCESS,                [no_command_specific_errors];
      2,  DATA_ENTRY_ERROR,       [invalid_selection];
      5,  MISC_ERROR,             [too_few_data_bytes_recieved];
      8,  DATA_ENTRY_WARNING,     [set_to_nearest_possible_value];
      16, MODE_ERROR,             [access_restricted];
   }
}

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Autogenerated Table
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#include "LR260_HA_menus.dd"

/*-----------------------------------------------------------------------------
   Description: Main table for Maintenance (specialist is autogenerated)
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Table_Main_Maintenance
{
   LABEL [Table_Main_Specialist_label];
   STYLE_TABLE
   ITEMS
   {
      Tab_s_ident,
      Tab_configure_menu,
      Tab_diagnostics,
      Tab_service_menu,
      Tab_language,
      Tab_s_certificates
   }
}

/*-----------------------------------------------------------------------------
   Description: MENU Bar
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Menu_Main_Specialist
{
   LABEL [main_menu];
   STYLE_MENU
   ITEMS
   {
      Menu_File,        /* use standard PDM method */
      Menu_S_Device,
      Menu_S_View,
      Menu_S_Options,   /* use standard PDM method */
      Menu_Help         /* use standard PDM method */
   }
}

MENU Menu_Main_Maintenance
{
   LABEL [main_menu];
   STYLE_MENU
   ITEMS
   {
      Menu_File,        /* use standard PDM method */
      Menu_M_Device,
      Menu_M_View,
      Menu_M_Options,   /* use standard PDM method */
      Menu_Help         /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: Device drop down menu
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Menu_S_Device
{
   LABEL  [menu_Device];
   STYLE_MENU
   ITEMS
   {
      std_CommWay,                 /* use standard PDM method */
      SEPARATOR,
      std_LoadinDevice,            /* use standard PDM method */
      std_LoadinPC,                /* use standard PDM method */
      SEPARATOR,
      #ifdef PDM52_SUPPORT
         OnlineDialog_auto_false_echo_suppression,
      #else
         method_quicksetup_wizard,
         method_menu_auto_false_echo_suppression,
         method_menu_tvt_shaper,
      #endif
      SEPARATOR,
      OfflineDialog_Maintenance_Status,
      method_self_test,
      method_master_reset,
      configuration_flag_reset,    /* use standard PDM method */
      SEPARATOR,
      method_pv_exchange_select,
      method_dac_trim,
      loop_test,                   /* use standard PDM method */
      SEPARATOR,
      OnlineDialog_hart_comm,      /* use standard PDM method */
   }
}

MENU Menu_M_Device
{
   LABEL  [menu_Device];
   STYLE_MENU
   ITEMS
   {
      std_LoadinDevice,            /* use standard PDM method */
      std_LoadinPC                 /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: View drop down menu
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Menu_S_View
{
   LABEL  [menu_View];
   STYLE_MENU
   ITEMS
   {
      OnlineWindow_display,
      SEPARATOR,
      OfflineDialog_im_functions,
      SEPARATOR,
      #ifdef PDM52_SUPPORT
         OnlineWindow_yt,
         OnlineWindow_echo,
      #else
         method_menu_trend,
         method_menu_echo_profile,
         method_menu_saved_echo,
      #endif
      SEPARATOR,
      OnlineWindow_status,
      OnlineWindow_wear,
      SEPARATOR,
      std_Funktionsleiste,       /* use standard PDM method */
      std_Statuszeile,           /* use standard PDM method */
      SEPARATOR,
      std_Update                 /* use standard PDM method */
   }
}

MENU Menu_M_View
{
   LABEL  [menu_View];
   STYLE_MENU
   ITEMS
   {
      OnlineWindow_display,
      SEPARATOR,
      OfflineDialog_im_functions,
      SEPARATOR,
      #ifdef PDM52_SUPPORT
         OnlineWindow_yt,
         OnlineWindow_echo,
      #else
         method_menu_trend,
         method_menu_echo_profile,
         method_menu_saved_echo,
      #endif
      SEPARATOR,
      OnlineWindow_status,
      OnlineWindow_wear,
      SEPARATOR,
      std_Funktionsleiste,       /* use standard PDM method */
      std_Statuszeile,           /* use standard PDM method */
      SEPARATOR,
      std_Update                 /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: Upload and download lists
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU download_variables
{
   LABEL  [menu_load_to_PC];
   ITEMS
   {
      DOWNLOADLIST,
      tag,
      descriptor,
      message,
      date,
      par_level_reading,
      par_space_reading,
      par_distance_reading,
      par_volume_reading,
      final_assembly_number,
      manufacturer_id,
      device_type,
      device_id,
      universal_revision,
      transmitter_revision,
      software_revision,
      hardware_revision,
      PV.ALARM_CODE,
      write_protect,
      DEVICE_Order_Number
   }
   PRE_READ_ACTIONS
   {
      method_determine_software_revision,
      method_pre_read_values
   }
   POST_READ_ACTIONS
   {
      method_post_read_values
   }
}

MENU upload_variables
{
   LABEL  [menu_load_to_device];
   ITEMS
   {
      UPLOADLIST,
      tag,
      descriptor,
      message,
      date
   }
   PRE_WRITE_ACTIONS
   {
      method_goto_program_mode,
      method_determine_software_revision,
      method_pre_write_values
   }
   POST_WRITE_ACTIONS
   {
      method_goto_run_mode
   }  
}

/* Graphic Elements -----------------------------------------------------------*/

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Methods called from autogenerated files
   Created by: Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
#include "LR260_HA_methods.dd"

/*-----------------------------------------------------------------------------
   Description: PRE_EDIT_ACTIONS for VARIABLE phys_device_description_local
   Created by: Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_preedit_dd_rev
{
   DEFINITION
   {
      phys_device_description_local = DD_VERSION;
      phys_device_description_local.VARIABLE_STATUS = 0;
   }
}

/*-----------------------------------------------------------------------------
   Description: ACTIONS for Upload and Download lists
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_pre_read_values
{
   DEFINITION
   {
      //_TRACE("################################# Pre Read Values");
      ReadCommand(read_quick_setup);
      ReadCommand(read_par_ma_function);
      ReadCommand(read_simple_quick_setup);
      ReadCommand(read_pv_units);
      ReadCommand(read_dynamic_variables_and_pv_current);
      //_TRACE("################################# Pre Read Values Done");
   }
}

METHOD method_post_read_values
{
   DEFINITION
   {
      //_TRACE("################################# Post Read Values");

      // This prevents an error caused by var_auto_tvt_range_local being larger
      // than the maximum. 
      // To duplicate the error:
      //   Reset the device to factory defaults
      //   Upload to PC
      //   Set sensor units to mm offline
      //   Download to device
      //   Reset the device to factory defaults
      //   Upload to PC  (Error occurs when upload finishes)
      var_auto_tvt_range_local = par_tb_auto_near_tvt_range;

      //_TRACE("################################# Post Read Values Done");
   }
}

METHOD method_pre_write_values
{
   DEFINITION
   {
      //_TRACE("################################# Pre Write Values");
      WriteCommand(write_quick_setup);
      WriteCommand(write_par_ma_function);
      WriteCommand(write_simple_quick_setup);
      //_TRACE("################################# Pre Write Values Done");
   }
}

/*-----------------------------------------------------------------------------
   Description: Standard method to show transfer button
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_set
{
   LABEL    [transfer];
   HELP     [transfer_help];
   DEFINITION
   {
   }
}

/*-----------------------------------------------------------------------------
   Description: post read action for DEVICE_Order_Number
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_post_read_actions_device_order_number
{
   DEFINITION
   {
      var_image_switch = 1;
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
