/*
$Id: Utility/softwarerevision.inc 1.5 2007/07/31 13:38:21EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/dd_library/common/lr_food3_hart_device_descriptions_common_library.pj $   $Locker:  $
*/

#ifndef SOFTWAREREVISION_INC
#define SOFTWAREREVISION_INC

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
      Check the software revision of the connected device to determine what is supported.
      
      If a menu has to be shown based on the phys_software_rev, when it is "2.01" or more.
         if ( var_software_revision_numeric > 2010000 ) ...
      !!!not:
         if ( var_software_revision_numeric > 201   ) ...
         
      Define FIRMWARE_REVISION as the variable that holds the software revision string.
      
      "var_software_revision_numeric" will hold the numeric version of the revision.
      
      "method_calculate_software_revision" must be called to initialize this value.
   
      Use the corresponding method once with the phys_device_description_local 
      pre_edit_action to calculate offline.
      
         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------
   
   Special Revision Notes -----------------------------------------------------

   Defines --------------------------------------------------------------------*/

/* Include Files --------------------------------------------------------------*/

/* Collections ----------------------------------------------------------------*/

/* Relations (Unit, Array, Refresh) -------------------------------------------*/

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description    Numerical representation of the phys_software_rev parameter.
   Created by:    GK
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_software_revision_numeric
{
	CLASS		LOCAL ;
	TYPE		UNSIGNED_INTEGER(4)
	{
		DEFAULT_VALUE 0 ;
	}
	HANDLING	READ;
}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: 
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_calculate_software_revision
{
   HELP "Format of the software revision parameter: x.xx.xx-xx or xx.xx.xx-xx";
   DEFINITION
   {
      char editRevision[20];
      char chr[2];
      long newRevision;
      int  n;
      int  digits;

      editRevision = FIRMWARE_REVISION;

      digits = 0;
      newRevision = 0;
      for (n = 0; n < strlen(editRevision); n++)
         {
         chr[0] = editRevision[n];
         if ((chr[0] >= '0') && (chr[0] <= '9')) 
            {
            newRevision = (newRevision * 10) + atoi(chr);
            digits++;
            }
         }
      while (digits < 7)
         {
         newRevision  *= 100;
         digits       += 2;
         }
      var_software_revision_numeric = newRevision;
   }
}
#endif // SOFTWAREREVISION_INC
/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/

