 /*
$Id: AutoTVT/autotvt.inc 1.9 2007/11/09 15:56:52EST Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/dd_library/common/lr_food3_hart_device_descriptions_common_library.pj $   $Locker:  $
*/
#ifndef AUTO_TVT_DD
#define AUTO_TVT_DD
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
		 Auto TVT dialog for a device that uses auto false echo suppression feature.
       
         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

       The user calls the method "method_menu_auto_false_echo_suppression" or this
       method can be added to a menu.
       
       The "autotvtopt.dd" file must be created, 
       Use the template with the name "autotvtopt.tpl.dd".
       
   Defines --------------------------------------------------------------------*/
#define AUTO_TVT_OFF   0
#define AUTO_TVT_ON    1
#define AUTO_TVT_LEARN 2

/* Include Files --------------------------------------------------------------*/
#include "autotvtopt.dd"

#ifndef AUTO_TVT_LEARN_DELAY
#define AUTO_TVT_LEARN_DELAY     1
#endif

/* Collections ----------------------------------------------------------------*/

/* Relations (Unit, Array, Refresh) -------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
UNIT AUTO_TVT_RANGE_UNITS_RELATION
{
   AUTO_TVT_RANGE_UNITS
   :
   var_auto_tvt_range_local
}


/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
var_auto_tvt_range_local LIKE VARIABLE AUTO_TVT_RANGE
{
   REDEFINE CLASS LOCAL;
}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU OnlineDialog_auto_false_echo_suppression
{
   LABEL AUTO_TVT_DIALOG_LABEL;
   HELP  AUTO_TVT_DIALOG_HELP; 
   STYLE_ONLINE_DIALOG
   ITEMS
   {
      AUTO_TVT_MODE (READ_ONLY),
      method_auto_near_tvt_learn,
      method_auto_near_tvt_turn_on,
      method_auto_near_tvt_turn_off,
      var_auto_tvt_range_local,
      method_auto_near_tvt_set_range,
      #ifndef HELP_SUPPORT
         #ifndef PDM52_SUPPORT
            COLUMNBREAK,
            image_afes_echoprofile,
         #endif
         AUTO_TVT_RANGE_UNITS (HIDDEN)
      #endif
   }
   PRE_EDIT_ACTIONS
   {
      DEFINITION
      {
         AUTO_TVT_RANGE_UNITS_READ_COMMAND;
         AUTO_TVT_READ_COMMAND;
         var_auto_tvt_range_local = AUTO_TVT_RANGE;
      }
   }
}

#ifndef PDM52_SUPPORT
   #ifndef HELP_SUPPORT
      IMAGE image_afes_echoprofile
      {
         PATH AUTO_TVT_IMAGE;
      }
   #endif
#endif

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifndef PDM52_SUPPORT
   METHOD method_menu_auto_false_echo_suppression
   {
      LABEL AUTO_TVT_DIALOG_LABEL;
      HELP  AUTO_TVT_DIALOG_HELP; 
      ACCESS ONLINE;
	   CLASS  INPUT;   
      DEFINITION
      {  
         long result;

         var_auto_tvt_range_local = AUTO_TVT_RANGE;

         MenuDisplay(OnlineDialog_auto_false_echo_suppression, AUTO_TVT_CLOSE_BUTTON, result);
      }
   } 
#endif

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_auto_near_tvt_learn
{          
   LABEL AUTO_TVT_LEARN_LABEL;
   HELP  AUTO_TVT_LEARN_HELP; 
   DEFINITION
   {
      AUTO_TVT_READ_COMMAND;
      AUTO_TVT_MODE = AUTO_TVT_LEARN;
      AUTO_TVT_WRITE_COMMAND;
      DELAY_TIME(AUTO_TVT_LEARN_DELAY);
   }
   VALIDITY
      IF (AUTO_TVT_MODE != AUTO_TVT_LEARN)
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

METHOD method_auto_near_tvt_turn_on
{          
   LABEL AUTO_TVT_TURN_ON_LABEL;
   HELP  AUTO_TVT_TURN_ON_HELP; 
   DEFINITION
   {
      if (AUTO_TVT_MODE == AUTO_TVT_OFF)
         {
         AUTO_TVT_READ_COMMAND;
         AUTO_TVT_MODE = AUTO_TVT_ON;
         AUTO_TVT_WRITE_COMMAND;
         }
   }
   VALIDITY
      IF (AUTO_TVT_MODE != AUTO_TVT_LEARN)
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

METHOD method_auto_near_tvt_turn_off
{          
   LABEL AUTO_TVT_TURN_OFF_LABEL;
   HELP  AUTO_TVT_TURN_OFF_HELP; 
   DEFINITION
   {
      if (AUTO_TVT_MODE == AUTO_TVT_ON)
         {
         AUTO_TVT_READ_COMMAND;
         AUTO_TVT_MODE = AUTO_TVT_OFF;
         AUTO_TVT_WRITE_COMMAND;
         }
   }
   VALIDITY
      IF (AUTO_TVT_MODE != AUTO_TVT_LEARN)
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

METHOD method_auto_near_tvt_set_range
{          
   LABEL AUTO_TVT_SET_RANGE_LABEL;
   HELP  AUTO_TVT_SET_RANGE_HELP; 
   DEFINITION
   {
      AUTO_TVT_READ_COMMAND;
      AUTO_TVT_RANGE = var_auto_tvt_range_local;
      AUTO_TVT_WRITE_COMMAND;
      
      /* read it back to make sure it got set properly */
      AUTO_TVT_READ_COMMAND;
      var_auto_tvt_range_local = AUTO_TVT_RANGE;
   }
   VALIDITY
      IF (AUTO_TVT_MODE != AUTO_TVT_LEARN)
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

METHOD method_auto_near_tvt_range_pre_edit
{          
   DEFINITION
   {
      var_auto_tvt_range_local = AUTO_TVT_RANGE;
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
