 /*
$Id: Utility/compatability.inc 1.10 2007/10/12 15:45:17EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/dd_library/common/lr_food3_hart_device_descriptions_common_library.pj $   $Locker:  $
*/

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
		 Library DD File.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------


   Defines --------------------------------------------------------------------*/
// Macro's to use until these builtin's are supported
#ifdef _PDM_

   #if _PDM_ < 700   // this is planned to be added to PDM version 7
      // string functions
      #define strequal(s1, s2) (s1==s2)    // (strcmp(s1, s2) == 0)

      // time functions
      #define SECONDS_PER_DAY (86400.0)
      #define AddTime(time_t, seconds) (time_t + (seconds / SECONDS_PER_DAY))
      #define DiffTime(time_t1, time_t0) ((time_t1 - time_t0) * SECONDS_PER_DAY)
   #else
      // string functions
      #define strequal(s1, s2) (strcmp(s1, s2) == 0)
   #endif   

   #if _PDM_ < 600   // not supported in pdm 5.2
      #define strtrim(s1)      (s1)
      #define strmid(s1,v1,v2) (s1)
      #define COLUMNBREAK      SEPARATOR
      #define ROWBREAK         SEPARATOR
   #endif   

   #define MULTILINE_25_2       STYLE "MULTILINE 25 2";
   #define MULTILINE_15_20      STYLE "MULTILINE 15 20";
   #define MULTILINE_20_20      STYLE "MULTILINE 20 20";
   #define MULTILINE_27_20      STYLE "MULTILINE 27 20";

   #ifdef _V602_
      #ifdef DD_MEANT_FOR_PDM52
         #define PDM52_SUPPORT
      #else
         #define EDDL_SUPPORT
      #endif
   #else
      #if GENERATE_602_HELP
         #define HELP_SUPPORT
      #else
         #define PDM52_SUPPORT
      #endif
   #endif

   #ifdef EDDL_SUPPORT
      /* Menu Styles */
      #define STYLE_ONLINE_WINDOW  STYLE WINDOW; ACCESS ONLINE;
      #define STYLE_ONLINE_DIALOG  STYLE DIALOG; ACCESS ONLINE;
      #define STYLE_OFFLINE_WINDOW STYLE WINDOW; ACCESS OFFLINE;
      #define STYLE_OFFLINE_DIALOG STYLE DIALOG; ACCESS OFFLINE;
      #define STYLE_PAGE           STYLE PAGE;
      #define STYLE_GROUP          STYLE GROUP;
      #define STYLE_TABLE          STYLE TABLE;
      #define STYLE_MENU           STYLE MENU;
      #define MENU_LABEL(label)    label,
   #else
      /* Menu Styles */
      #define STYLE_ONLINE_WINDOW  ACCESS ONLINE;
      #define STYLE_ONLINE_DIALOG  ACCESS ONLINE;
      #define STYLE_OFFLINE_WINDOW ACCESS OFFLINE;
      #define STYLE_OFFLINE_DIALOG ACCESS OFFLINE;
      #define STYLE_PAGE
      #define STYLE_GROUP
      #define STYLE_TABLE
      #define STYLE_MENU
      #define MENU_LABEL(label)    SEPARATOR,
   #endif

#endif   
/* Include Files --------------------------------------------------------------*/

/* Collections ----------------------------------------------------------------*/

/* Relations (Unit, Array, Refresh) -------------------------------------------*/

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifdef EDDL_SUPPORT
#else
VARIABLE var_EDDL_error
{
    LABEL " . ";
    HELP  " ";
    CLASS LOCAL;
    TYPE  ASCII
    {
        DEFAULT_VALUE  " ";
    }
    HANDLING READ;
}

#endif

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/



/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
