 /*
$Id: EchoProfile/saveechoprofile.inc 1.18 2007/10/15 15:59:36EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/dd_library/common/lr_food3_hart_device_descriptions_common_library.pj $   $Locker:  $
*/
#ifndef SAVEECHOPROFILE_INC
#define SAVEECHOPROFILE_INC
#endif

#ifndef ECHOPROFILE_INC
#error LIBRARY ERROR - This file requires that 'echoprofile.inc' be included first!!!
#endif
/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
       Library File to save echo profiles data and display the profiles.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------
       Requires the "echoprofile.inc" echo profile module to collect the profiles
       that are used by this module

       To display saved profiles the user calls the method "method_menu_saved_echo"
       or this method can be added to a menu.

       If used this file must be included after the the "echoprofile.inc" file and the
       define "#define SAVEECHOPROFILE_INC" must be included before the "echoprofile.inc" file.

   Defines --------------------------------------------------------------------*/
#define MAXIMUM_SAVED_PROFILES      50      // var_list_select needs to be updated if this value is changed

#ifndef HELP_SUPPORT
   #define MACRO_PROFILE_LIST_ELEMENTS(I)               \
            IF (list_profile.COUNT > I)                 \
               {                                        \
                  {I, list_profile[ I ].PROFILE_NAME }, \
               }

   #define HAVE_SAVED_PROFILES                   \
               IF (list_profile.COUNT > 0)       \
                  {                              \
                  TRUE;                          \
                  }                              \
               ELSE                              \
                  {                              \
                  FALSE;                         \
                  }

#else
   #define HAVE_SAVED_PROFILES            TRUE
   #define MACRO_PROFILE_LIST_ELEMENTS(I) {I, list_profile[ I ].PROFILE_NAME },
#endif

/* Include Files --------------------------------------------------------------*/

/* Collections ----------------------------------------------------------------*/
#ifndef HELP_SUPPORT
   COLLECTION collection_profile_info
   {
      MEMBERS
      {
         PROFILE_NAME,              var_name_profile_saved;
         COMMENT,                   var_comment_profile_saved;
         DATE_STAMP,                var_date_profile_saved;

         ECHO,                      ECHO_PROFILE_ECHO_POINTS;
         TVT,                       ECHO_PROFILE_TVT_POINTS;
         X_AXIS_START,              ECHO_PROFILE_X_MIN;
         X_AXIS_END,                ECHO_PROFILE_X_MAX;
         X_AXIS_INC_PROFILE,        ECHO_PROFILE_ECHO_POINT_INCREMENT;
         X_AXIS_INC_TVT,            ECHO_PROFILE_TVT_POINT_INCREMENT;
         X_AXIS_UNITS,              ECHO_PROFILE_X_UNITS;
         Y_AXIS_START,              ECHO_PROFILE_Y_MIN;
         Y_AXIS_END,                ECHO_PROFILE_Y_MAX;

         X_AXIS_MARKER,             var_local_echo_marker_distance;
         Y_AXIS_MARKER_END,         var_local_echo_marker_bottom;
         Y_AXIS_MARKER_START,       var_local_echo_marker_top;

         X_AXIS_WINDOW_START,       var_local_window_sill_start;
         X_AXIS_WINDOW_END,         var_local_window_sill_end;
         Y_AXIS_WINDOW_SILL_OFFSET, var_local_window_sill_offset;
         Y_AXIS_WINDOW_SILL,        var_local_window_sill;

         READING,                   ECHO_PROFILE_PAR_READING;
         READING_UNIT,              ECHO_PROFILE_PAR_READING_UNIT;
         CONFIDENCE,                ECHO_PROFILE_PAR_CONFIDENCE;
         ECHO_STRENGTH,             ECHO_PROFILE_PAR_ECHO_STRENGTH;
         BLANKING,                  ECHO_PROFILE_PAR_NEAR_BLANKING;
         ALGORITHM,                 ECHO_PROFILE_PAR_ALGORITHM;
      }
   }
#endif

/* Relations (Unit, Array, Refresh) -------------------------------------------*/
#ifndef HELP_SUPPORT
   LIST list_profile
   {
      TYPE   collection_profile_info;
   }
#endif

ARRAY saved_tvt_point
{
   TYPE local_data_point_y;
   NUMBER_OF_ELEMENTS ECHO_PROFILE_NUMBER_TVT_POINTS;
}

ARRAY saved_echo_profile_point
{
    TYPE local_data_point_y;
    NUMBER_OF_ELEMENTS ECHO_PROFILE_NUMBER_ECHO_POINTS;

}

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_profile_saved
{
   CLASS LOCAL;
   TYPE ENUMERATED(1)
   {
      DEFAULT_VALUE 0;
      { 1,   "true"  },
      { 0,   "false" }
   }
}

VARIABLE var_date_profile_saved
{
   LABEL  ECHO_PROFILE_DATE_SAVED_LABEL;
   HELP   ECHO_PROFILE_DATE_SAVED_HELP;
   CLASS  LOCAL;
   TYPE   DATE_AND_TIME;
   VALIDITY HAVE_SAVED_PROFILES;
   HANDLING READ;
}

VARIABLE var_comment_profile_saved
{
   LABEL  ECHO_PROFILE_COMMENT_LABEL;
   HELP   ECHO_PROFILE_COMMENT_HELP;
   CLASS  LOCAL;
   TYPE   ASCII ( 50 );
   MULTILINE_25_2
   VALIDITY HAVE_SAVED_PROFILES;
   PRE_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_comment
   }
   POST_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_comment
   }
}

VARIABLE var_name_profile_saved
{
   LABEL  ECHO_PROFILE_NAME_PROFILE_LABEL;
   HELP   ECHO_PROFILE_NAME_PROFILE_HELP;
   CLASS  LOCAL;
   TYPE   ASCII (25);
   VALIDITY HAVE_SAVED_PROFILES;
   PRE_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_name
   }
   POST_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_name
   }
}

VARIABLE var_currently_saved_profile_local
{
   LABEL  ECHO_PROFILE_NAME_PROFILE_LABEL;
   HELP   ECHO_PROFILE_NAME_PROFILE_HELP;
   CLASS  LOCAL;
   TYPE   ASCII (25);
   HANDLING READ;
   PRE_EDIT_ACTIONS
   {
      method_pre_post_edit_local_name
   }
   POST_EDIT_ACTIONS
   {
      method_pre_post_edit_local_name
   }
}

VARIABLE var_index_list
{
   CLASS LOCAL;
   TYPE INDEX list_profile;
}

VARIABLE var_list_select
{
   LABEL  ECHO_PROFILE_VAR_LIST_SELECT_LABEL;
   HELP   ECHO_PROFILE_VAR_LIST_SELECT_HELP;
   CLASS  LOCAL;
   POST_EDIT_ACTIONS
   {
      DEFINITION
      {
         method_draw_graph();
      }
   }
   VALIDITY HAVE_SAVED_PROFILES;
   TYPE     ENUMERATED
   {
      MACRO_PROFILE_LIST_ELEMENTS( 0)
      MACRO_PROFILE_LIST_ELEMENTS( 1)
      MACRO_PROFILE_LIST_ELEMENTS( 2)
      MACRO_PROFILE_LIST_ELEMENTS( 3)
      MACRO_PROFILE_LIST_ELEMENTS( 4)
      MACRO_PROFILE_LIST_ELEMENTS( 5)
      MACRO_PROFILE_LIST_ELEMENTS( 6)
      MACRO_PROFILE_LIST_ELEMENTS( 7)
      MACRO_PROFILE_LIST_ELEMENTS( 8)
      MACRO_PROFILE_LIST_ELEMENTS( 9)
      MACRO_PROFILE_LIST_ELEMENTS(10)
      MACRO_PROFILE_LIST_ELEMENTS(11)
      MACRO_PROFILE_LIST_ELEMENTS(12)
      MACRO_PROFILE_LIST_ELEMENTS(13)
      MACRO_PROFILE_LIST_ELEMENTS(14)
      MACRO_PROFILE_LIST_ELEMENTS(15)
      MACRO_PROFILE_LIST_ELEMENTS(16)
      MACRO_PROFILE_LIST_ELEMENTS(17)
      MACRO_PROFILE_LIST_ELEMENTS(18)
      MACRO_PROFILE_LIST_ELEMENTS(19)
      MACRO_PROFILE_LIST_ELEMENTS(20)
      MACRO_PROFILE_LIST_ELEMENTS(21)
      MACRO_PROFILE_LIST_ELEMENTS(22)
      MACRO_PROFILE_LIST_ELEMENTS(23)
      MACRO_PROFILE_LIST_ELEMENTS(24)
      MACRO_PROFILE_LIST_ELEMENTS(25)
      MACRO_PROFILE_LIST_ELEMENTS(26)
      MACRO_PROFILE_LIST_ELEMENTS(27)
      MACRO_PROFILE_LIST_ELEMENTS(28)
      MACRO_PROFILE_LIST_ELEMENTS(29)
      MACRO_PROFILE_LIST_ELEMENTS(30)
      MACRO_PROFILE_LIST_ELEMENTS(31)
      MACRO_PROFILE_LIST_ELEMENTS(32)
      MACRO_PROFILE_LIST_ELEMENTS(33)
      MACRO_PROFILE_LIST_ELEMENTS(34)
      MACRO_PROFILE_LIST_ELEMENTS(35)
      MACRO_PROFILE_LIST_ELEMENTS(36)
      MACRO_PROFILE_LIST_ELEMENTS(37)
      MACRO_PROFILE_LIST_ELEMENTS(38)
      MACRO_PROFILE_LIST_ELEMENTS(39)
      MACRO_PROFILE_LIST_ELEMENTS(40)
      MACRO_PROFILE_LIST_ELEMENTS(41)
      MACRO_PROFILE_LIST_ELEMENTS(42)
      MACRO_PROFILE_LIST_ELEMENTS(43)
      MACRO_PROFILE_LIST_ELEMENTS(44)
      MACRO_PROFILE_LIST_ELEMENTS(45)
      MACRO_PROFILE_LIST_ELEMENTS(46)
      MACRO_PROFILE_LIST_ELEMENTS(47)
      MACRO_PROFILE_LIST_ELEMENTS(48)
      MACRO_PROFILE_LIST_ELEMENTS(49)
   }
}

par_distance_marker_saved  LIKE VARIABLE ECHO_PROFILE_PAR_DISTANCE
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES;
   REDEFINE CONSTANT_UNIT par_x_axis_units_saved(par_x_axis_units_saved);
}
par_tb_conf_long_saved     LIKE VARIABLE ECHO_PROFILE_PAR_CONFIDENCE
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES;
}

par_tb_echo_strength_saved LIKE VARIABLE ECHO_PROFILE_PAR_ECHO_STRENGTH
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES;
}

par_tb_algorithm_saved     LIKE VARIABLE ECHO_PROFILE_PAR_ALGORITHM
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES;
}

par_near_blanking_saved    LIKE VARIABLE ECHO_PROFILE_PAR_NEAR_BLANKING
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES;
   REDEFINE CONSTANT_UNIT par_x_axis_units_saved(par_x_axis_units_saved);
}

par_x_axis_units_saved     LIKE VARIABLE ECHO_PROFILE_X_UNITS
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES;
}

par_reading_saved          LIKE VARIABLE ECHO_PROFILE_PAR_READING
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES;
   REDEFINE CONSTANT_UNIT par_reading_units_saved(par_reading_units_saved);
}

par_reading_units_saved    LIKE VARIABLE ECHO_PROFILE_PAR_READING_UNIT
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES;
}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Menus for Echo Profile Save Functionality
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Group_list_echo_profile
{
   LABEL  ECHO_PROFILE_GROUP_LIST_LABEL;
   STYLE_GROUP
   ITEMS
   {
      var_currently_saved_profile_local,
      method_save_list,
      method_delete_list
   }
   VALIDITY (var_local_echo_profile_taken == ECHO_PROFILE_TAKEN);
}

/*-----------------------------------------------------------------------------
   Description: Menus for show saved profile functionality
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU OfflineWindow_saved_echo
{
   LABEL  ECHO_PROFILE_MENU_SAVED_ECHO_LABEL;
   ITEMS
   {
      Page_saved_echo
   }
}

MENU Page_saved_echo
{
   LABEL  ECHO_PROFILE_MENU_SAVED_ECHO_LABEL;
   HELP   ECHO_PROFILE_MENU_SAVED_ECHO_HELP;
   STYLE_PAGE
   ITEMS
   {
      Group_select_profile,
      ROWBREAK,
      #ifndef HELP_SUPPORT
         graph_saved_echo,
      #endif
      COLUMNBREAK,
      par_reading_saved          (READ_ONLY),
      par_distance_marker_saved  (READ_ONLY),
      par_tb_conf_long_saved     (READ_ONLY),
      par_tb_echo_strength_saved (READ_ONLY),
      par_near_blanking_saved    (READ_ONLY),
      par_tb_algorithm_saved     (READ_ONLY)
   }
}

MENU Group_select_profile
{
   LABEL  ECHO_PROFILE_GROUP_SELECT_PROFILE_LABEL;
   STYLE_GROUP
   ITEMS
   {
      var_list_select,
      var_comment_profile_saved,
      var_date_profile_saved,
      COLUMNBREAK,
      method_delete_list_local,
      method_save_comment_local
   }
}

MENU OfflineDialog_edit_profile
{
   LABEL ECHO_PROFILE_SAVE_AS_LABEL;
   HELP  ECHO_PROFILE_SAVE_AS_HELP;
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      var_name_profile_saved,
      var_comment_profile_saved,
      var_date_profile_saved
   }
}

/* Visual component Definitions -----------------------------------------------*/
#ifndef HELP_SUPPORT
   GRAPH graph_saved_echo
   {
      X_AXIS saved_x_axis;
      MEMBERS
      {
         WAVEFORM_SAVED_ECHO_PROFILE_ECHO,   waveform_saved_echo;
         WAVEFORM_SAVED_ECHO_PROFILE_TVT,    waveform_saved_tvt;
         WAVEFORM_SAVED_ECHO_PROFILE_MARKER, waveform_saved_profile_marker;
         WAVEFORM_SAVED_ECHO_PROFILE_WINDOW, waveform_saved_window_marker;
      }
      WIDTH LARGE;
      HEIGHT X_LARGE;
      VALIDITY HAVE_SAVED_PROFILES;
   }

   WAVEFORM waveform_saved_echo
   {
      Y_AXIS saved_y_axis;

      TYPE YT
      {
         X_INITIAL
            IF( list_profile.COUNT > 0 )
               {
               list_profile[var_index_list].X_AXIS_START;
               }
            ELSE
               {
               0;
               }
         X_INCREMENT
            IF( list_profile.COUNT > 0 )
               {
               list_profile[var_index_list].X_AXIS_INC_PROFILE;
               }
            ELSE
               {
               0;
               }
         Y_VALUES
         {
            saved_echo_profile_point;
         }
         NUMBER_OF_POINTS ECHO_PROFILE_NUMBER_ECHO_POINTS;
         LINE_COLOR ECHO_PROFILE_WAVEFORM_ECHO_PROFILE_COLOR;
      }
      INIT_ACTIONS
      {
         DEFINITION
         {
            var_list_select = 0;
            method_draw_graph();
         }
      }
   }

   WAVEFORM waveform_saved_tvt
   {
      Y_AXIS saved_y_axis;
      TYPE YT
      {
         X_INITIAL
            IF( list_profile.COUNT > 0 )
               {
               list_profile[var_index_list].X_AXIS_START;
               }
            ELSE
               {
               0;
               }
         X_INCREMENT
            IF( list_profile.COUNT > 0 )
               {
               list_profile[var_index_list].X_AXIS_INC_TVT;
               }
            ELSE
               {
               0;
               }
         Y_VALUES
         {
             saved_tvt_point;
         }
         NUMBER_OF_POINTS ECHO_PROFILE_NUMBER_TVT_POINTS;
         LINE_COLOR ECHO_PROFILE_WAVEFORM_TVT_COLOR;
      }
   }

   WAVEFORM waveform_saved_profile_marker
   {
      Y_AXIS saved_y_axis;
      TYPE XY
      {
         X_VALUES
         {
            IF( list_profile.COUNT > 0 )
               {
               list_profile[var_index_list].X_AXIS_MARKER,
               list_profile[var_index_list].X_AXIS_MARKER
               }
            ELSE
               {
               0,
               0
               }
         }
         Y_VALUES
         {
            IF( list_profile.COUNT > 0 )
               {
               list_profile[var_index_list].Y_AXIS_MARKER_END,
               list_profile[var_index_list].Y_AXIS_MARKER_START
               }
            ELSE
               {
               0,
               0
               }
         }
         NUMBER_OF_POINTS 2;
         LINE_COLOR ECHO_PROFILE_WAVEFORM_PROFILE_MARKER_COLOR;
      }
   }

   WAVEFORM waveform_saved_window_marker
   {
      Y_AXIS saved_y_axis;
      TYPE XY
      {
         X_VALUES
         {
            IF( list_profile.COUNT > 0 )
               {
               list_profile[var_index_list].X_AXIS_WINDOW_START,
               list_profile[var_index_list].X_AXIS_WINDOW_START,
               list_profile[var_index_list].X_AXIS_WINDOW_END,
               list_profile[var_index_list].X_AXIS_WINDOW_END
               }
            ELSE
               {
               0,
               0,
               0,
               0
               }
         }
         Y_VALUES
         {
            IF( list_profile.COUNT > 0 )
               {
               list_profile[var_index_list].Y_AXIS_WINDOW_SILL_OFFSET,
               list_profile[var_index_list].Y_AXIS_WINDOW_SILL,
               list_profile[var_index_list].Y_AXIS_WINDOW_SILL,
               list_profile[var_index_list].Y_AXIS_WINDOW_SILL_OFFSET
               }
            ELSE
               {
               0,
               0,
               0,
               0
               }
         }
         NUMBER_OF_POINTS 4;
         LINE_COLOR ECHO_PROFILE_WAVEFORM_WINDOW_MARKER_COLOR;
      }
   }

   AXIS saved_y_axis
   {
      LABEL  ECHO_PROFILE_AXIS_PROFILE_LABEL;
      MIN_VALUE
         IF( list_profile.COUNT > 0 )
            {
            list_profile[var_index_list].Y_AXIS_START;
            }
         ELSE
            {
            0;
            }
      MAX_VALUE
         IF( list_profile.COUNT > 0 )
            {
            list_profile[var_index_list].Y_AXIS_END;
            }
         ELSE
            {
            0;
            }
      CONSTANT_UNIT ECHO_PROFILE_Y_UNITS_LABEL;
   }

   AXIS saved_x_axis
   {
      LABEL  ECHO_PROFILE_AXIS_DISTANCE_LABEL;
      MIN_VALUE
         IF( list_profile.COUNT > 0 )
            {
            list_profile[var_index_list].X_AXIS_START;
            }
         ELSE
            {
            0;
            }
      MAX_VALUE
         IF( list_profile.COUNT > 0 )
            {
            list_profile[var_index_list].X_AXIS_END;
            }
         ELSE
            {
            0;
            }
      CONSTANT_UNIT
         IF( list_profile.COUNT > 0 )
            {
            par_x_axis_units_saved(par_x_axis_units_saved);
            }
         ELSE
            {
            0;
            }
   }
#endif

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Methods for Echo Profile Save Functionality
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_reset_save_profile
{
   DEFINITION
   {
      var_profile_saved = 0;
      var_date_profile_saved = GetCurrentDateAndTime();
      var_currently_saved_profile_local = ECHO_PROFILE_NOT_SAVED_LABEL;
   }
}

METHOD method_menu_saved_echo
{
   LABEL  ECHO_PROFILE_MENU_SAVED_ECHO_LABEL;
   HELP   ECHO_PROFILE_MENU_SAVED_ECHO_HELP;
   ACCESS OFFLINE;
   DEFINITION
   {
      long result;
      MenuDisplay(OfflineWindow_saved_echo, ECHO_PROFILE_OK_BUTTON, result);
   }
   VALIDITY HAVE_SAVED_PROFILES;
}

METHOD method_save_list
{
   LABEL  ECHO_PROFILE_SAVE_LABEL;
   HELP   ECHO_PROFILE_SAVE_HELP;
   DEFINITION
   {
      #ifndef HELP_SUPPORT
         DD_STRING oldName;
         DD_STRING oldComment;
         long result;
         int count;
         int theIndex;

         if ((!var_profile_saved) && (list_profile.COUNT >= MAXIMUM_SAVED_PROFILES ))
            {
            PUT_MESSAGE(ECHO_PROFILE_MAXIMUM_SAVED_PROFILES);
            return;
            }

         if (!var_profile_saved)    // To save the profile
            {
            var_name_profile_saved = "";
            var_comment_profile_saved = "";

            ListInsert(list_profile, list_profile.COUNT, collection_profile_info);
            }
         else                      // To edit the saved profile
            {
            oldName    = var_name_profile_saved;
            oldComment = var_comment_profile_saved;
            }

         MenuDisplay(OfflineDialog_edit_profile, ECHO_PROFILE_CONFIRM_BUTTONS, result);

         // validate the name
         if (result == 0)  // if ok
            {
            // check that there is a name, if not use the date
            var_name_profile_saved = strtrim(var_name_profile_saved);
            if (strlen(var_name_profile_saved) <= 0)
               {
               var_name_profile_saved = var_date_profile_saved;
               }
            else
               {
               var_name_profile_saved = var_name_profile_saved;
               }

            // check that the name is not duplicated
            for (count = 0; count < (list_profile.COUNT - 1); count++)
               {
               if (strequal(list_profile[count].PROFILE_NAME, var_name_profile_saved))
                  {
                  result = 1;
                  PUT_MESSAGE(ECHO_PROFILE_DUPLICATE_NAME_LABEL);
                  break;
                  }
               }
            }

         if (!var_profile_saved)    // To save the profile
            {
            if (result == 0) // if still ok after name was validated
               {
               var_currently_saved_profile_local                 = var_name_profile_saved;
               list_profile[list_profile.COUNT - 1].PROFILE_NAME = var_name_profile_saved;
               list_profile[list_profile.COUNT - 1].COMMENT      = var_comment_profile_saved;
               var_profile_saved                                 = 1;
               }
            else
               {
               var_currently_saved_profile_local = ECHO_PROFILE_NOT_SAVED_LABEL;
               ListDeleteElementAt(list_profile, list_profile.COUNT - 1);
               }
            }
         else                      // To edit the saved profile
            {
            if (result == 0) // if still ok after name was validated
               {
               var_currently_saved_profile_local                 = var_name_profile_saved;
               list_profile[list_profile.COUNT - 1].PROFILE_NAME = var_name_profile_saved;
               list_profile[list_profile.COUNT - 1].COMMENT      = var_comment_profile_saved;
               }
            else
               {
               var_name_profile_saved    = oldName;
               var_comment_profile_saved = oldComment;
               }
            }
      #endif
   }
   #ifndef HELP_SUPPORT
      VALIDITY
         IF ((list_profile.COUNT < MAXIMUM_SAVED_PROFILES) || (var_profile_saved))
            {
            TRUE;
            }
         ELSE
            {
            FALSE;
            }
   #endif
}

METHOD method_delete_list
{
   LABEL  ECHO_PROFILE_DELETE_LABEL;
   HELP   ECHO_PROFILE_DELETE_HELP;
   DEFINITION
   {
      int result;

      if (!var_profile_saved)
         {
         return;
         }

      result = SELECT_FROM_LIST(ECHO_PROFILE_DELETE_MESSAGE_LABEL, ECHO_PROFILE_CONFIRM_BUTTONS);
      if (result)
         {
         return;
         }

      var_currently_saved_profile_local = ECHO_PROFILE_NOT_SAVED_LABEL;
      ListDeleteElementAt(list_profile, list_profile.COUNT - 1);
      var_profile_saved = 0;
   }
}

/*-----------------------------------------------------------------------------
   Description: Methods for show saved profile functionality
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_draw_graph
{
   DEFINITION
   {
      int point;

      if( var_list_select < 0 )
         {
         return;
         }

     var_index_list= var_list_select;

      for (point = 0; point < NUMBER_ECHO_POINTS; point++)
         {
         saved_echo_profile_point[point] = list_profile[var_index_list].ECHO[point];
         }
      for (point = 0; point < NUMBER_TVT_POINTS; point++)
         {
         saved_tvt_point[point] = list_profile[var_index_list].TVT[point];
         }

      var_date_profile_saved     = list_profile[var_index_list].DATE_STAMP;
      var_name_profile_saved     = list_profile[var_index_list].PROFILE_NAME;
      var_comment_profile_saved  = list_profile[var_index_list].COMMENT;
      par_distance_marker_saved  = list_profile[var_index_list].X_AXIS_MARKER;
      par_tb_conf_long_saved     = list_profile[var_index_list].CONFIDENCE;
      par_tb_echo_strength_saved = list_profile[var_index_list].ECHO_STRENGTH;
      par_tb_algorithm_saved     = list_profile[var_index_list].ALGORITHM;
      par_x_axis_units_saved     = list_profile[var_index_list].X_AXIS_UNITS;
      par_reading_saved          = list_profile[var_index_list].READING;
      par_reading_units_saved    = list_profile[var_index_list].READING_UNIT;
      par_near_blanking_saved    = list_profile[var_index_list].BLANKING;
   }
}

METHOD method_delete_list_local
{
   LABEL  ECHO_PROFILE_DELETE_LABEL;
   HELP   ECHO_PROFILE_DELETE_HELP;
   DEFINITION
   {
      int result;

      result = SELECT_FROM_LIST(ECHO_PROFILE_DELETE_MESSAGE_LABEL, ECHO_PROFILE_CONFIRM_BUTTONS);
      if (result)
         {
         return;
         }

      ListDeleteElementAt(list_profile, var_index_list);
      if (list_profile.COUNT > 0)
         {
         var_list_select = 0;
         method_draw_graph();
         }
   }
   VALIDITY HAVE_SAVED_PROFILES;
}

METHOD method_save_comment_local
{
   LABEL  ECHO_PROFILE_SAVE_LABEL;
   HELP   ECHO_PROFILE_SAVE_HELP;
   DEFINITION
   {
      int result;

      result = SELECT_FROM_LIST(ECHO_PROFILE_SAVE_COMMENT_MESSAGE_LABEL, ECHO_PROFILE_CONFIRM_BUTTONS);
      if (result)
         {
         var_comment_profile_saved = list_profile[var_index_list].COMMENT;
         }
      else
         {
         list_profile[var_index_list].COMMENT = var_comment_profile_saved;
         }
   }
   VALIDITY HAVE_SAVED_PROFILES;
}

METHOD method_pre_post_edit_saved_comment
{
   DEFINITION
   {
      var_comment_profile_saved = strmid(strtrim(var_comment_profile_saved), 0, 50);
   }
}

METHOD method_pre_post_edit_saved_name
{
   DEFINITION
   {
      var_name_profile_saved = strmid(strtrim(var_name_profile_saved), 0, 25);
   }
}

METHOD method_pre_post_edit_local_name
{
   DEFINITION
   {
      var_currently_saved_profile_local = strmid(strtrim(var_currently_saved_profile_local), 0, 25);
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
