 /*
$Id: Trend/showtrend.inc 1.8 2007/08/16 17:10:48EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/dd_library/common/lr_food3_hart_device_descriptions_common_library.pj $   $Locker:  $
*/

#ifndef SHOWTREND_INC
#define SHOWTREND_INC
#endif

#ifndef TREND_INC
#error LIBRARY ERROR - This file requires that 'trend.inc' be included first!!!
#endif
/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
       Library File to save trend data and display the data.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------
       Requires the "trend.inc" trending module to collect the data that is used
       by this module
       
       To display saved trends the user calls the method "method_menu_saved_trend" 
       or this method can be added to a menu.
       
       If used this file must be included after the the "trend.inc" file and the
       define "#define SHOWTREND_INC" must be included before the "trend.inc" file.
       
   Defines --------------------------------------------------------------------*/
#define HAVE_SAVED_TRENDS             \
            IF (list_trend.COUNT > 0)  \
               {                      \
               TRUE;                  \
               }                      \
            ELSE                      \
               {                      \
               FALSE;                 \
               }
               
#define MACRO_TREND_LIST_ELEMENTS( index )               \
         IF ( list_trend.COUNT > index )                 \
            {                                            \
               {  index, list_trend[index].TREND_NAME }, \
            }

#define VALUE_INT_TRUE 1
#define VALUE_INT_FALSE 0

#define TREND_MAX_POINTS 1440

/* Include Files --------------------------------------------------------------*/

/* Collections ----------------------------------------------------------------*/
COLLECTION collection_trend_info
{
   MEMBERS
   {
      TREND_NAME,         var_trend_name;
      COMMENT,            var_trend_comment;
      
      DATE_STAMP_START,   var_date_trend_start_save;
      DATE_STAMP_STOP,    var_date_trend_stop_save;

      TREND_DATA,         array_trend_measured_level;             
      
      X_AXIS_POINTS,      var_trend_index_measured_level;
      X_AXIS_INC,         var_trend_frequency;
            
      Y_AXIS_START,       var_trend_lrv;
      Y_AXIS_END,         var_trend_urv;
      Y_AXIS_UNITS,       var_trend_unit;
   }
}

/* Relations ------------------------------------------------------------------*/
LIST list_trend
{
   TYPE    collection_trend_info;
}

REFRESH REFRESH_LIST_TREND
{
   list_trend
   :
   var_trend_current_item,
   list_trend.COUNT
}


/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Variables in the collection_trend_info collection    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_trend_name
{
   LABEL  TREND_NAME_LABEL;
   CLASS  LOCAL;
   TYPE   ASCII (50); 
}

VARIABLE var_trend_comment
{
   LABEL  TREND_PROFILE_COMMENT_LABEL;
   CLASS  LOCAL;
   MULTILINE_25_2
   TYPE   ASCII (50); 
}

VARIABLE var_date_trend_start_save
{
   LABEL  TREND_VAR_DATE_START_SAVE_LABEL;
   HELP   TREND_VAR_DATE_START_SAVE_HELP;
   CLASS  LOCAL;
   TYPE   DATE_AND_TIME;
   HANDLING READ;   
}

var_date_trend_stop_save LIKE VARIABLE var_date_trend_start_save
{
   REDEFINE LABEL TREND_VAR_DATE_STOP_SAVE_LABEL;
   REDEFINE HELP  TREND_VAR_DATE_STOP_SAVE_HELP;
}

ARRAY array_trend_measured_level
{
   TYPE   var_trend_measured_level;
   NUMBER_OF_ELEMENTS TREND_MAX_POINTS;
}

VARIABLE var_trend_measured_level
{
   CLASS LOCAL;
   TYPE  FLOAT; 
}

VARIABLE var_trend_index_measured_level
{
   CLASS LOCAL;
   TYPE INTEGER (4) 
   {
      DEFAULT_VALUE 0;
      MIN_VALUE     0;
      MAX_VALUE     65535;
   }      
}

VARIABLE var_trend_frequency
{
   CLASS  LOCAL;
   TYPE   UNSIGNED_INTEGER (4)
   {
      DEFAULT_VALUE 1;
      MIN_VALUE 1;
      MAX_VALUE 60;
   }   
   HANDLING
      IF (var_trend_saving == 0)
      {
         READ & WRITE;
      }
      ELSE
      {
         READ;
      }
}

VARIABLE var_trend_lrv 
{
   CLASS LOCAL;
   TYPE  FLOAT; 
}

VARIABLE var_trend_urv 
{
   CLASS LOCAL;
   TYPE  FLOAT; 
}

var_trend_unit LIKE VARIABLE TREND_LEVEL_UNITS
{
   REDEFINE CLASS LOCAL;
}

/*-----------------------------------------------------------------------------
   Description: Variables in the collection_trend_info collection    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
   Description:     
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

VARIABLE var_trend_saving
{
   CLASS  LOCAL;
   TYPE   ENUMERATED(1)
   {
      DEFAULT_VALUE VALUE_INT_FALSE;
      {VALUE_INT_TRUE,  "true"},
      {VALUE_INT_FALSE, "false"}
   }
}

var_current_trend_name LIKE VARIABLE var_trend_name
{
   REDEFINE HANDLING READ;
   REDEFINE VALIDITY TRUE;
}

/*
FILE file_trend_saved
{
   MEMBERS
   {
      TREND_DATA,  list_trend;
   }     
}
*/

var_trend_next_sample LIKE VARIABLE var_date_trend_start_save {}

var_trend_current_time LIKE VARIABLE var_date_trend_start_save {}

VARIABLE var_trend_max_length
{
   LABEL  TREND_MAX_LEN_VARIABLE_LABEL;
   CLASS  LOCAL;
   TYPE   ENUMERATED (1)
   {
      DEFAULT_VALUE 10;
      {1,  TREND_LENGTH_04_HOURS_LABEL},      
      {10, TREND_LENGTH_4_HOURS_LABEL},
      {30, TREND_LENGTH_12_HOURS_LABEL},      
      {60, TREND_LENGTH_24_HOURS_LABEL}
   }   
   CONSTANT_UNIT [h];
   HANDLING READ;
}

VARIABLE var_trend_frequency_local
{
   LABEL  TREND_FREQUENCY_VARIABLE_LABEL;
   CLASS  LOCAL;
   TYPE   ENUMERATED (1)
   {
      DEFAULT_VALUE 10;
      {1,  TREND_FREQUENCY_1_LABEL},      
      {10, TREND_FREQUENCY_10_LABEL},
      {30, TREND_FREQUENCY_30_LABEL},      
      {60, TREND_FREQUENCY_60_LABEL}
   }   
   CONSTANT_UNIT [s];
   POST_EDIT_ACTIONS
   {
      DEFINITION
      {
         var_trend_max_length = var_trend_frequency_local;
      }
   }   
}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Variables used to display saved trend   
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_trend_current_index
{
   CLASS LOCAL;
   TYPE INDEX list_trend;
}

VARIABLE var_trend_current_item
{
   CLASS  LOCAL;
   TYPE   ENUMERATED
   {
      DEFAULT_VALUE 0;
      MACRO_TREND_LIST_ELEMENTS( 0)
      MACRO_TREND_LIST_ELEMENTS( 1)
      MACRO_TREND_LIST_ELEMENTS( 2)
      MACRO_TREND_LIST_ELEMENTS( 3)
      MACRO_TREND_LIST_ELEMENTS( 4)
      MACRO_TREND_LIST_ELEMENTS( 5)
      MACRO_TREND_LIST_ELEMENTS( 6)
      MACRO_TREND_LIST_ELEMENTS( 7)
      MACRO_TREND_LIST_ELEMENTS( 8)
      MACRO_TREND_LIST_ELEMENTS( 9)
      MACRO_TREND_LIST_ELEMENTS(10)
      MACRO_TREND_LIST_ELEMENTS(11)
      MACRO_TREND_LIST_ELEMENTS(12)
      MACRO_TREND_LIST_ELEMENTS(13)
      MACRO_TREND_LIST_ELEMENTS(14)
      MACRO_TREND_LIST_ELEMENTS(15)
      MACRO_TREND_LIST_ELEMENTS(16)
      MACRO_TREND_LIST_ELEMENTS(17)
      MACRO_TREND_LIST_ELEMENTS(18)
      MACRO_TREND_LIST_ELEMENTS(19)
      MACRO_TREND_LIST_ELEMENTS(20)
      MACRO_TREND_LIST_ELEMENTS(21)
      MACRO_TREND_LIST_ELEMENTS(22)
      MACRO_TREND_LIST_ELEMENTS(23)
      MACRO_TREND_LIST_ELEMENTS(24)
      MACRO_TREND_LIST_ELEMENTS(25)
      MACRO_TREND_LIST_ELEMENTS(26)
      MACRO_TREND_LIST_ELEMENTS(27)
      MACRO_TREND_LIST_ELEMENTS(28)
      MACRO_TREND_LIST_ELEMENTS(29)
      MACRO_TREND_LIST_ELEMENTS(30)
      MACRO_TREND_LIST_ELEMENTS(31)
      MACRO_TREND_LIST_ELEMENTS(32)
      MACRO_TREND_LIST_ELEMENTS(33)
      MACRO_TREND_LIST_ELEMENTS(34)
      MACRO_TREND_LIST_ELEMENTS(35)
      MACRO_TREND_LIST_ELEMENTS(36)
      MACRO_TREND_LIST_ELEMENTS(37)
      MACRO_TREND_LIST_ELEMENTS(38)
      MACRO_TREND_LIST_ELEMENTS(39)
      MACRO_TREND_LIST_ELEMENTS(40)
      MACRO_TREND_LIST_ELEMENTS(41)
      MACRO_TREND_LIST_ELEMENTS(42)
      MACRO_TREND_LIST_ELEMENTS(43)
      MACRO_TREND_LIST_ELEMENTS(44)
      MACRO_TREND_LIST_ELEMENTS(45)
      MACRO_TREND_LIST_ELEMENTS(46)
      MACRO_TREND_LIST_ELEMENTS(47)
      MACRO_TREND_LIST_ELEMENTS(48)
      MACRO_TREND_LIST_ELEMENTS(49)
   }
   VALIDITY HAVE_SAVED_TRENDS;
   POST_EDIT_ACTIONS
   {
      method_get_current_trend_data
   }
}

var_trend_current_comment     LIKE VARIABLE var_trend_comment
{
}

var_trend_current_start_time  LIKE VARIABLE var_date_trend_start_save
{
}

var_trend_current_stop_time   LIKE VARIABLE var_date_trend_stop_save 
{
}

array_saved_trend_points      LIKE ARRAY    array_trend_measured_level    
{
}

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Menu group for Trend Save Functionality    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Group_save_trend
{
   LABEL  TREND_MENU_GROUP_SAVE_LABEL;    
   STYLE_GROUP
   ITEMS
   {  
      var_current_trend_name,
      COLUMNBREAK,
      method_trend_save_start,
      method_trend_save_stop
   }
}

MENU menu_edit_trend                           
{
   LABEL  TREND_MENU_SAVE_AS_LABEL;
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      var_trend_name            (DISPLAY_VALUE),
      var_trend_comment         (DISPLAY_VALUE),
      var_date_trend_start_save (DISPLAY_VALUE),
      var_trend_frequency_local (DISPLAY_VALUE),
      var_trend_max_length      (DISPLAY_VALUE)
   }
}

/*-----------------------------------------------------------------------------
   Description: Menus for Show Saved Trend Functionality    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU OfflineWindow_saved_trend
{
   LABEL  TREND_METHOD_MENU_SAVED_LABEL;
   STYLE_OFFLINE_WINDOW
   ITEMS
   {
      Page_saved_trend
   }
}

MENU Page_saved_trend
{
   LABEL TREND_METHOD_MENU_SAVED_LABEL;
   STYLE_PAGE
   ITEMS
   {
      Group_saved_trend_start_end,
      #ifndef HELP_SUPPORT
         graph_saved_trend
      #endif
   }
}

MENU Group_saved_trend_start_end
{
   STYLE_GROUP
   ITEMS
   {  
      var_trend_current_item,
      var_trend_current_comment,
      var_trend_current_start_time,
      var_trend_current_stop_time,
      COLUMNBREAK,
      method_delete_saved_trend_list,
      method_change_saved_trend_comment
   }
}

/* Visual component Definitions -----------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Displays graph area, for Show Saved Trend Functionality   
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifndef HELP_SUPPORT
   GRAPH graph_saved_trend
   {
      X_AXIS x_axis_saved_trend;
      MEMBERS
      {
         WAVEFORM_SAVED_TREND_1, waveform_saved_trend;
      }
      WIDTH    LARGE;
      HEIGHT   X_LARGE;
      VALIDITY HAVE_SAVED_TRENDS;
   }

   WAVEFORM waveform_saved_trend
   {
      Y_AXIS y_axis_saved_trend;
      TYPE YT
      {
         X_INITIAL        0;
         X_INCREMENT
            IF( list_trend.COUNT > 0 ) 
               { 
               list_trend[var_trend_current_index].X_AXIS_INC; 
               } 
            ELSE 
               { 
               0; 
               }
      
         NUMBER_OF_POINTS 
            IF( list_trend.COUNT > 0 ) 
               { 
               list_trend[var_trend_current_index].X_AXIS_POINTS; 
               } 
            ELSE 
               { 
               0; 
               }
         Y_VALUES
         {
            array_saved_trend_points;
         }
      }
      INIT_ACTIONS
      {
         DEFINITION
         {
            var_trend_current_index = 0;
            method_get_current_trend_data();
         }
      }
   }

   AXIS y_axis_saved_trend
   {
      LABEL  TREND_AXIS_LEVEL_LABEL;
      MIN_VALUE
         IF( list_trend.COUNT > 0 ) 
            { 
            list_trend[var_trend_current_index].Y_AXIS_START; 
            } 
         ELSE 
            { 
            0; 
            }
      MAX_VALUE
         IF( list_trend.COUNT > 0 ) 
            { 
            list_trend[var_trend_current_index].Y_AXIS_END; 
            } 
         ELSE 
            { 
            0; 
            }
      CONSTANT_UNIT 
         IF( list_trend.COUNT > 0 ) 
            { 
            var_trend_unit(list_trend[var_trend_current_index].Y_AXIS_UNITS); 
            } 
         ELSE 
            { 
            ""; 
            }
   }

   AXIS x_axis_saved_trend
   {
      LABEL  TREND_AXIS_TIME_LABEL;
      MIN_VALUE 0;
      MAX_VALUE
         IF( list_trend.COUNT > 0 ) 
            { 
            list_trend[var_trend_current_index].X_AXIS_POINTS * list_trend[var_trend_current_index].X_AXIS_INC; 
            } 
         ELSE 
            { 
            0; 
            }
      CONSTANT_UNIT TREND_AXIS_TIME_UNITS;
   }
#endif

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Methods for Trend Save Functionality    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_trend_save_init
{
   DEFINITION
   {
      var_current_trend_name = TREND_NOT_SAVING_LABEL;
      var_trend_saving = 0;
   }
}

METHOD method_trend_save_start
{
   LABEL  TREND_METHOD_START_LABEL;
   DEFINITION
   {      
      long result;
      DD_STRING name;
      DD_STRING theComment;
      int index;


      if (var_trend_saving)
         {
         return;
         }

      if (list_trend.COUNT < 50)
         {         
         var_trend_name    = "";
         var_trend_comment = "";
         var_date_trend_start_save = GetCurrentDateAndTime();
         ListInsert(list_trend, list_trend.COUNT, collection_trend_info);
         
         MenuDisplay(menu_edit_trend, TREND_CONFIRM_BUTTONS, result);
         
         if (result == 0)
            {
            var_date_trend_start_save = GetCurrentDateAndTime();
            
            var_trend_name = strtrim(var_trend_name);
            if (strlen(var_trend_name) <= 0)
               {
               var_trend_name = var_date_trend_start_save;
               }
                     
            var_trend_frequency            = var_trend_frequency_local;
            var_trend_index_measured_level = 0;
            var_trend_next_sample          = var_date_trend_start_save;
            var_trend_saving               = 1;

            list_trend[list_trend.COUNT - 1].DATE_STAMP_START   = var_date_trend_start_save;
            list_trend[list_trend.COUNT - 1].TREND_NAME         = var_trend_name;
            list_trend[list_trend.COUNT - 1].COMMENT            = var_trend_comment;
            list_trend[list_trend.COUNT - 1].Y_AXIS_UNITS       = TREND_LEVEL_UNITS;
            list_trend[list_trend.COUNT - 1].Y_AXIS_START       = TREND_LEVEL_LRV;
            list_trend[list_trend.COUNT - 1].Y_AXIS_END         = TREND_LEVEL_URV;
            list_trend[list_trend.COUNT - 1].X_AXIS_INC         = var_trend_frequency;
            
            var_current_trend_name = var_trend_name;
         
            }
         else
            {
            var_current_trend_name = TREND_NOT_SAVING_LABEL;
            ListDeleteElementAt(list_trend, list_trend.COUNT - 1);                        
            }
         }
   }
}

METHOD method_trend_save_save_data
{
   DEFINITION
   {
      if( var_trend_saving == 1 )         
         {
         var_trend_current_time = GetCurrentDateAndTime();   
         while (var_trend_next_sample >= var_trend_current_time)
            {
            if (var_trend_index_measured_level < TREND_MAX_POINTS)
               {
               list_trend[list_trend.COUNT - 1].TREND_DATA[var_trend_index_measured_level] = TREND_LEVEL_VALUE;
               list_trend[list_trend.COUNT - 1].DATE_STAMP_STOP = var_trend_current_time;
               var_trend_index_measured_level = var_trend_index_measured_level + 1;
               list_trend[list_trend.COUNT - 1].X_AXIS_POINTS   = var_trend_index_measured_level;
               } 
            else // end of save
               {
               method_trend_save_stop();
               break;
               }
            var_trend_next_sample = AddTime(var_trend_next_sample, var_trend_frequency_local);
            }
         }
   }
}

METHOD method_trend_save_stop
{
   LABEL  TREND_METHOD_STOP_LABEL;
   DEFINITION
   {      
      var_current_trend_name = TREND_NOT_SAVING_LABEL;
      var_trend_saving = 0;
       _TRACE("Saving trend #" + itoa(list_trend.COUNT) + " #####");
   }
}

/*-----------------------------------------------------------------------------
   Description: Methods for Show Saved Trend Functionality    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_menu_saved_trend
{
   LABEL  TREND_METHOD_MENU_SAVED_LABEL;
   ACCESS OFFLINE;
   DEFINITION
   {  
      long result;
      MenuDisplay(OfflineWindow_saved_trend, TREND_OK_BUTTON, result);
   }
   VALIDITY HAVE_SAVED_TRENDS;
} 

METHOD method_delete_saved_trend_list
{
   LABEL  TREND_METHOD_LIST_DELETE_LABEL;
   DEFINITION
   {
      int result;
      
      if (list_trend.COUNT == 0)
         {
         return;
         }
      result = SELECT_FROM_LIST( TREND_DELETE_MESSAGE, TREND_CONFIRM_BUTTONS);
      if (!result)
         {
         ListDeleteElementAt(list_trend, var_trend_current_index);
         var_trend_current_index = var_trend_current_index - 1;  
         }
   }
}

METHOD method_change_saved_trend_comment
{
   LABEL  TREND_METHOD_SAVE_LABEL;
   DEFINITION
   {
      int result;
      
      result = SELECT_FROM_LIST(TREND_SAVE_COMMENT_MESSAGE, TREND_CONFIRM_BUTTONS);
      if ( result )
         {
         var_trend_current_comment = list_trend[var_trend_current_index].COMMENT;
         }
      else
         {
         list_trend[var_trend_current_index].COMMENT = var_trend_current_comment;      
         }
   }
   VALIDITY HAVE_SAVED_TRENDS;   
}

METHOD method_get_current_trend_data
{
   DEFINITION
   {
      int i;
      
      for (i = 0; i < list_trend[var_trend_current_index].X_AXIS_POINTS; i++)
      {
         array_saved_trend_points[i] = list_trend[var_trend_current_index].TREND_DATA[i];
      }
   
      var_trend_current_start_time  = list_trend[var_trend_current_index].DATE_STAMP_START;
      var_trend_current_stop_time   = list_trend[var_trend_current_index].DATE_STAMP_STOP;
      var_trend_current_comment     = list_trend[var_trend_current_index].COMMENT;
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/

