/*
$Id: Maintenance/smpi_maintenance.inc 1.16 2007/09/06 11:27:54EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/dd_library/common/lr_food3_hart_device_descriptions_common_library.pj $   $Locker:  $
*/

#ifndef SMPI_MAINTENANCE_INC_INCLUDED
#define SMPI_MAINTENANCE_INC_INCLUDED
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
       Secondary DD file.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

   Defines --------------------------------------------------------------------*/
/* Unit selection macro's */
#define   POWERED_HOURS_UNITS                         \
   SELECT (par_pb_powered_hours_sec2_unit)            \
      {                                               \
      CASE 241: [hours_label];                        \
      CASE 242: [days_label];                         \
      CASE 243: [years_label];                        \
      }

#define   SENSOR_TIMER_UNIT                           \
   SELECT (par_tb_sensor_operating_hours_unit)        \
      {                                               \
      CASE 241: [hours_label];                        \
      CASE 242: [days_label];                         \
      CASE 243: [years_label];                        \
      }

#define   CALIBRATION_TIMER_UNIT                      \
   SELECT (par_pb_calibration_maintenance_timer_unit) \
      {                                               \
      CASE 241: [hours_label];                        \
      CASE 242: [days_label];                         \
      CASE 243: [years_label];                        \
      }

#define   SERVICE_TIMER_UNIT                          \
   SELECT (par_tb_service_maintenance_timer_unit)     \
      {                                               \
      CASE 241: [hours_label];                        \
      CASE 242: [days_label];                         \
      CASE 243: [years_label];                        \
      }

#define TIME_UNITS_CONVERSION_FACTOR(units)           \
   double factor;                                     \
   switch (units)                                     \
      {                                               \
      case 241:                                       \
         factor = SECONDS_PER_HOUR;                   \
         break;                                       \
      case 242:                                       \
         factor = SECONDS_PER_DAY;                    \
         break;                                       \
      case 243:                                       \
         factor = SECONDS_PER_YEAR;                   \
         break;                                       \
      default:                                        \
         factor = 1;                                  \
         break;                                       \
      }

/* Unit conversion macro's */
#define TO_POWERED_HOURS_UNITS(value)                        \
   SELECT (par_pb_powered_hours_sec2_unit)                   \
      {                                                      \
      CASE 241: value * SECONDS_PER_YEAR / SECONDS_PER_HOUR; \
      CASE 242: value * SECONDS_PER_YEAR / SECONDS_PER_DAY;  \
      CASE 243: value;                                       \
      }

#define TO_SENSOR_TIMER_UNITS(value)                         \
   SELECT (par_tb_sensor_operating_hours_unit)               \
      {                                                      \
      CASE 241: value * SECONDS_PER_YEAR / SECONDS_PER_HOUR; \
      CASE 242: value * SECONDS_PER_YEAR / SECONDS_PER_DAY;  \
      CASE 243: value;                                       \
      }

#define TO_CALIBRATION_TIMER_UNITS(value)                    \
   SELECT (par_pb_calibration_maintenance_timer_unit)        \
      {                                                      \
      CASE 241: value * SECONDS_PER_YEAR / SECONDS_PER_HOUR; \
      CASE 242: value * SECONDS_PER_YEAR / SECONDS_PER_DAY;  \
      CASE 243: value;                                       \
      }

#define TO_SERVICE_TIMER_UNITS(value)                        \
   SELECT (par_tb_service_maintenance_timer_unit)            \
      {                                                      \
      CASE 241: value * SECONDS_PER_YEAR / SECONDS_PER_HOUR; \
      CASE 242: value * SECONDS_PER_YEAR / SECONDS_PER_DAY;  \
      CASE 243: value;                                       \
      }

/* Include Files --------------------------------------------------------------*/

/* Collections ----------------------------------------------------------------*/

/* Relations ------------------------------------------------------------------*/

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Maintenance dialog displayed under diagnostic status
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Page_Maintenance
{
   LABEL  [Menu_Maintenance_label];
   ACCESS ONLINE;
   STYLE_PAGE
   ITEMS
   {
      Group_ProductLifetime,
      Group_SensorLifetime,
      Group_Service,
      Group_Calibration
   }
}

MENU Group_ProductLifetime
{
   LABEL  [Page_ProductLifetime_label];
   STYLE_GROUP
   ITEMS
   {
      par_pb_device_maintenance_status,
      par_pb_device_maintenance_ack,
      SEPARATOR,
      method_ProductLifetime_ack
   }
}

MENU Group_SensorLifetime
{
   LABEL  [Page_SensorLifetime_label];
   STYLE_GROUP
   ITEMS
   {
      par_tb_sensor_maintenance_status,
      par_tb_sensor_maintenance_ack,
      SEPARATOR,
      method_SensorLifetime_ack
   }
}

MENU Group_Service
{
   LABEL  [Page_service_label];
   STYLE_GROUP
   ITEMS
   {
      par_tb_service_maintenance_status,
      par_tb_service_maintenance_ack,
      SEPARATOR,
      method_mpnf_service_ack
   }
}

MENU Group_Calibration
{
   LABEL  [Page_Calibration_label];
   STYLE_GROUP
   ITEMS
   {
      par_pb_calibration_maintenance_status,
      par_pb_calibration_maintenance_ack,
      SEPARATOR,
      method_mpnf_Calibration_ack
   }
}

/*-----------------------------------------------------------------------------
   Description: Maintenance dialog displayed under device menu
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU OfflineDialog_Maintenance_Status
{
   LABEL  [Menu_Maintenance_label];
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      Page_ProductLifetime,
      Page_SensorLifetime,
      Page_ServiceInterval,
      Page_CalibrationInterval
   }
}

MENU Page_ProductLifetime
{
   LABEL  [OnlineDialog_ProductLifetime_label];
   STYLE_PAGE
   ITEMS
   {
      par_pb_powered_hours_sec2 (HIDDEN),
      par_pb_powered_hours_sec2_local (READ_ONLY),
      par_pb_device_rest_life_time (HIDDEN),
      par_pb_device_rest_life_time_local (READ_ONLY),
      par_pb_device_warning_limit_1 (HIDDEN),
      par_pb_device_warning_limit_1_local,
      par_pb_device_warning_limit_2 (HIDDEN),
      par_pb_device_warning_limit_2_local,
      par_pb_device_activation,
      par_pb_device_expected_lifetime_local,
      par_pb_device_expected_lifetime (HIDDEN),
      par_pb_powered_hours_sec2_unit,
      method_read_mpnf_OpHours,
      method_write_mpnf_OpHours,
      method_lifetime_snooze
   }
}

MENU Page_SensorLifetime
{
   LABEL  [OnlineDialog_SensorLifetime_label];
   STYLE_PAGE
   ITEMS
   {
      par_tb_sensor_operating_hours(HIDDEN),
      par_tb_sensor_operating_hours_local (READ_ONLY),
      par_tb_sensor_rest_life_time  (HIDDEN),
      par_tb_sensor_rest_life_time_local (READ_ONLY),
      par_tb_sensor_warning_limit_1  (HIDDEN),
      par_tb_sensor_warning_limit_1_local,
      par_tb_sensor_warning_limit_2 (HIDDEN),
      par_tb_sensor_warning_limit_2_local,
      par_tb_sensor_activation,
      par_tb_sensor_expected_lifetime (HIDDEN),
      par_tb_sensor_expected_lifetime_local,
      par_tb_sensor_operating_hours_unit,
      method_read_mpnf_SensorOpHours,
      method_write_mpnf_SensorOpHours,
      method_SensorLifetime_complete,
      method_sensor_lifetime_snooze
   }
}

MENU Page_ServiceInterval
{
   LABEL  [OnlineDialog_service_label];
   STYLE_PAGE
   ITEMS
   {
      par_tb_service_maintenance_timer (HIDDEN),
      par_tb_service_maintenance_timer_local (READ_ONLY),
      par_tb_service_rest_life_time (HIDDEN),
      par_tb_service_rest_life_time_local (READ_ONLY),
      par_tb_service_warning_limit_1  (HIDDEN),
      par_tb_service_warning_limit_1_local,
      par_tb_service_warning_limit_2(HIDDEN) ,
      par_tb_service_warning_limit_2_local,
      par_tb_service_maintenace_activation,
      par_tb_service_interval (HIDDEN),
      par_tb_service_interval_local,
      par_tb_service_maintenance_timer_unit,
      method_read_mpnf_Service,
      method_write_mpnf_Service,
      method_mpnf_service_complete
   }
}

MENU Page_CalibrationInterval
{
   LABEL  [OnlineDialog_Calibration_label];
   STYLE_PAGE
   ITEMS
   {
      par_pb_calibration_maintenance_timer (HIDDEN),
      par_pb_calibration_maintenance_timer_local (READ_ONLY),
      par_pb_calibration_rest_life_time (HIDDEN),
      par_pb_calibration_rest_life_time_local (READ_ONLY),
      par_pb_calibration_warning_limit_1  (HIDDEN),
      par_pb_calibration_warning_limit_1_local,
      par_pb_calibration_warning_limit_2  (HIDDEN),
      par_pb_calibration_warning_limit_2_local,
      par_pb_calibration_activation,
      par_pb_calibration_interval  (HIDDEN),
      par_pb_calibration_interval_local,
      par_pb_calibration_maintenance_timer_unit,
      method_read_mpnf_Calibration,
      method_write_mpnf_Calibration,
      method_mpnf_Calibration_complete
   }
}

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Acknowledge methods
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_ProductLifetime_ack
{
   LABEL [acknowledge_label];
   HELP  [acknowledge_help];
   DEFINITION
   {
      ReadCommand(read_pbDevMaintLifeAck);
      par_pb_device_lifetime_maintenance_ack = 1;
      WriteCommand(write_pbDevMaintLifeAck);
   }
}

METHOD method_SensorLifetime_ack
{
   LABEL [acknowledge_label];
   HELP  [acknowledge_help];
   DEFINITION
   {
      ReadCommand(read_tbSensorMaintLifeAck);
      par_tb_sensor_lifetime_maintenance_ack = 1;
      WriteCommand(write_tbSensorMaintLifeAck);
   }
}

METHOD method_mpnf_service_ack
{
   LABEL [acknowledge_label];
   HELP  [acknowledge_help];
   DEFINITION
   {
      ReadCommand(read_tbServIntAck);
      par_tb_service_acknowledge = 1;
      WriteCommand(write_tbServIntAck);
   }
}

METHOD method_mpnf_Calibration_ack
{
   LABEL [acknowledge_label];
   HELP  [acknowledge_help];
   DEFINITION
   {
      ReadCommand(read_pbCalIntAck);
      par_pb_calibration_acknowledge = 1;
      WriteCommand(write_pbCalIntAck);
   }
}

/*-----------------------------------------------------------------------------
   Description: mp&f configuration dialog methods
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_SensorLifetime_complete
{
   LABEL [method_SensorLifetime_complete_label];
   HELP  [method_SensorLifetime_complete_help];
   DEFINITION
   {
      ReadCommand(read_tbSensorMaintLifeAck);
      par_tb_sensor_operating_hours = 0;
      WriteCommand(write_tbSensorMaintLifeAck);
   }
}

METHOD method_mpnf_service_complete
{
   LABEL [method_mpnf_service_complete_label];
   HELP  [method_mpnf_service_complete_help];
   DEFINITION
   {
      ReadCommand(read_tbServMaintTimer);
      par_tb_service_maintenance_timer = 0;
      WriteCommand(write_tbServMaintTimer);
   }
}

METHOD method_mpnf_Calibration_complete
{
   LABEL [method_mpnf_Calibration_complete_label];
   HELP  [method_mpnf_Calibration_complete_help];
   DEFINITION
   {
      ReadCommand(read_pbCalMaintTimer);
      par_pb_calibration_maintenance_timer = 0;
      WriteCommand(write_pbCalMaintTimer);
   }
}

METHOD method_lifetime_snooze
{
   LABEL [Snooze_label];
   HELP  [Snooze_help];
   DEFINITION
   {
      long exp_life_time;
      ReadCommand(read_pbDevMaintLifeAck);
      exp_life_time = par_pb_device_expected_lifetime;
      exp_life_time = exp_life_time + SECONDS_PER_YEAR;
      if (exp_life_time > MAX_LIFETIME_SECONDS)
         {
         exp_life_time = MAX_LIFETIME_SECONDS;
         }
      par_pb_device_expected_lifetime = exp_life_time;
      WriteCommand(write_pbDevMaintLifeAck);
      ReadCommand(read_pbDevMaintLifeAck);
   }
}

METHOD method_sensor_lifetime_snooze
{
   LABEL [Snooze_label];
   HELP  [Snooze_help];
   DEFINITION
   {
      long exp_life_time;
      ReadCommand(read_tbSensorMaintLifeAck);
      exp_life_time = par_tb_sensor_expected_lifetime;
      exp_life_time = exp_life_time + SECONDS_PER_YEAR;
      if (exp_life_time > MAX_LIFETIME_SECONDS)
         {
         exp_life_time = MAX_LIFETIME_SECONDS;
         }
      par_tb_sensor_expected_lifetime = exp_life_time;
      WriteCommand(write_tbSensorMaintLifeAck);
      ReadCommand(read_tbServStatusAck);
   }
}

METHOD method_read_mpnf_OpHours
{
   LABEL [method_read_mpnf_OpHours_label];
   HELP  [method_read_mpnf_OpHours_help];
   DEFINITION
   {
      ReadCommand(read_par_pb_powered_hours_sec2);
      ReadCommand(read_pbDevRestLifeStatus);
      ReadCommand(read_pbDevRestLifeStatus);
      ReadCommand(read_pbDevMaintLimits);
      ReadCommand(read_pbDevMaintLifeAck);
   }
}

METHOD method_write_mpnf_OpHours
{
   LABEL [method_write_mpnf_OpHours_label];
   HELP  [method_write_mpnf_OpHours_help];
   DEFINITION
   {
      WriteCommand(write_pbDevMaintLimits);
      WriteCommand(write_pbDevMaintLifeAck);
   }
}

METHOD method_read_mpnf_Calibration
{
   LABEL [method_read_mpnf_Calibration_label];
   HELP  [method_read_mpnf_Calibration_help];
   DEFINITION
   {
      ReadCommand(read_pbCalMaintTimer);
      ReadCommand(read_pbCalStatusAck);
      ReadCommand(read_pbCalLimits);
      ReadCommand(read_pbCalIntAck);
   }
}

METHOD method_write_mpnf_Calibration
{
   LABEL [method_write_mpnf_Calibration_label];
   HELP  [method_write_mpnf_Calibration_help];
   DEFINITION
   {
      WriteCommand(write_pbCalLimits);
      WriteCommand(write_pbCalIntAck);
   }
}

METHOD method_read_mpnf_Service
{
   LABEL [method_read_mpnf_Service_label];
   HELP  [method_read_mpnf_Service_help];
   DEFINITION
   {
      ReadCommand(read_tbServMaintTimer);
      ReadCommand(read_tbServStatusAck);
      ReadCommand(read_tbServLimits);
      ReadCommand(read_tbServIntAck);
   }
}

METHOD method_write_mpnf_Service
{
   LABEL [method_write_mpnf_Service_label];
   HELP  [method_write_mpnf_Service_help];
   DEFINITION
   {
      WriteCommand(write_tbServLimits);
      WriteCommand(write_tbServIntAck);
   }
}

METHOD method_read_mpnf_SensorOpHours
{
   LABEL [method_read_mpnf_SensorOpHours_label];
   HELP  [method_read_mpnf_SensorOpHours_help];
   DEFINITION
   {
      ReadCommand(read_tbSensorRestLifeStatus);
      ReadCommand(read_tbSensorMaintLimits);
      ReadCommand(read_tbSensorMaintLifeAck);
   }
}

METHOD method_write_mpnf_SensorOpHours
{
   LABEL [method_write_mpnf_SensorOpHours_label];
   HELP  [method_write_mpnf_SensorOpHours_help];
   DEFINITION
   {
      WriteCommand(write_tbSensorMaintLimits);
      WriteCommand(write_tbSensorMaintLifeAck);
   }
}

/*-----------------------------------------------------------------------------
   Description: mp&f table methods
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_transfer_mpnf_OpHours
{
   LABEL [method_transfer_mpnf_OpHours_label];
   DEFINITION
   {
      method_write_mpnf_OpHours();
   }
}

METHOD method_transfer_mpnf_Calibration
{
   LABEL [method_transfer_mpnf_Calibration_label];
   DEFINITION
   {
      method_write_mpnf_Calibration();
   }
}

METHOD method_transfer_mpnf_Service
{
   LABEL [method_transfer_mpnf_Service_label];
   DEFINITION
   {
      method_write_mpnf_Service();
   }
}

METHOD method_transfer_mpnf_SensorOpHours
{
   LABEL [method_transfer_mpnf_SensorOpHours_label];
   DEFINITION
   {
      method_write_mpnf_SensorOpHours();
   }
}

/*-----------------------------------------------------------------------------
   Description: mp&f ACTIONS
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_post_read_par_pb_powered_hours_sec2
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_powered_hours_sec2_local = par_pb_powered_hours_sec2 / factor;
      par_pb_powered_hours_sec2_local.VARIABLE_STATUS = par_pb_powered_hours_sec2.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_powered_hours_sec2_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_powered_hours_sec2 = par_pb_powered_hours_sec2_local * factor;
      par_pb_powered_hours_sec2.VARIABLE_STATUS = par_pb_powered_hours_sec2_local.VARIABLE_STATUS;
   }
}

METHOD method_pre_edit_par_pb_powered_hours_sec2_unit
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_powered_hours_sec2_local = par_pb_powered_hours_sec2 / factor;
      par_pb_device_warning_limit_1_local = par_pb_device_warning_limit_1 / factor;
      par_pb_device_warning_limit_2_local = par_pb_device_warning_limit_2 / factor;
      par_pb_device_expected_lifetime_local = par_pb_device_expected_lifetime / factor;
      par_pb_device_rest_life_time_local = par_pb_device_rest_life_time / factor;
   }
}

METHOD method_post_edit_par_pb_powered_hours_sec2_unit
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_powered_hours_sec2_local = par_pb_powered_hours_sec2 / factor;
      par_pb_device_warning_limit_1_local = par_pb_device_warning_limit_1 / factor;
      par_pb_device_warning_limit_2_local = par_pb_device_warning_limit_2 / factor;
      par_pb_device_expected_lifetime_local = par_pb_device_expected_lifetime / factor;
      par_pb_device_rest_life_time_local = par_pb_device_rest_life_time / factor;

      par_pb_powered_hours_sec2.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_powered_hours_sec2_local.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_device_warning_limit_1.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_device_warning_limit_1_local.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_device_warning_limit_2.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_device_warning_limit_2_local.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_device_expected_lifetime.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_device_expected_lifetime_local.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_device_rest_life_time.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
      par_pb_device_rest_life_time_local.VARIABLE_STATUS = par_pb_powered_hours_sec2_unit.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_pb_device_rest_life_time
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_device_rest_life_time_local = par_pb_device_rest_life_time / factor;
      par_pb_device_rest_life_time_local.VARIABLE_STATUS = par_pb_device_rest_life_time.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_device_rest_life_time_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_device_rest_life_time = par_pb_device_rest_life_time_local * factor;
      par_pb_device_rest_life_time.VARIABLE_STATUS = par_pb_device_rest_life_time_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_pb_device_warning_limit_1
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_device_warning_limit_1_local = par_pb_device_warning_limit_1 / factor;
      par_pb_device_warning_limit_1_local.VARIABLE_STATUS = par_pb_device_warning_limit_1.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_device_warning_limit_1_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_device_warning_limit_1 = par_pb_device_warning_limit_1_local * factor;
      par_pb_device_warning_limit_1.VARIABLE_STATUS = par_pb_device_warning_limit_1_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_pb_device_warning_limit_2
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_device_warning_limit_2_local = par_pb_device_warning_limit_2 / factor;
      par_pb_device_warning_limit_2_local.VARIABLE_STATUS = par_pb_device_warning_limit_2.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_device_warning_limit_2_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_device_warning_limit_2 = par_pb_device_warning_limit_2_local * factor;
      par_pb_device_warning_limit_2.VARIABLE_STATUS = par_pb_device_warning_limit_2_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_pb_device_expected_lifetime
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_device_expected_lifetime_local = par_pb_device_expected_lifetime / factor;
      par_pb_device_expected_lifetime_local.VARIABLE_STATUS = par_pb_device_expected_lifetime.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_device_expected_lifetime_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_powered_hours_sec2_unit)
      par_pb_device_expected_lifetime = par_pb_device_expected_lifetime_local * factor;
      par_pb_device_expected_lifetime.VARIABLE_STATUS = par_pb_device_expected_lifetime_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_pb_calibration_maintenance_timer
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_maintenance_timer_local = par_pb_calibration_maintenance_timer / factor;
      par_pb_calibration_maintenance_timer_local.VARIABLE_STATUS = par_pb_calibration_maintenance_timer.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_calibration_maintenance_timer_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_maintenance_timer = par_pb_calibration_maintenance_timer_local * factor;
      par_pb_calibration_maintenance_timer.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_local.VARIABLE_STATUS;
   }
}

METHOD method_pre_edit_par_pb_calibration_maintenance_timer_unit
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_maintenance_timer_local = par_pb_calibration_maintenance_timer / factor;
      par_pb_calibration_interval_local = par_pb_calibration_interval / factor;
      par_pb_calibration_rest_life_time_local = par_pb_calibration_rest_life_time / factor;
      par_pb_calibration_warning_limit_1_local = par_pb_calibration_warning_limit_1 / factor;
      par_pb_calibration_warning_limit_2_local = par_pb_calibration_warning_limit_2 / factor;
  }
}

METHOD method_post_edit_par_pb_calibration_maintenance_timer_unit
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_maintenance_timer_local = par_pb_calibration_maintenance_timer / factor;
      par_pb_calibration_interval_local = par_pb_calibration_interval / factor;
      par_pb_calibration_rest_life_time_local = par_pb_calibration_rest_life_time / factor;
      par_pb_calibration_warning_limit_1_local = par_pb_calibration_warning_limit_1 / factor;
      par_pb_calibration_warning_limit_2_local = par_pb_calibration_warning_limit_2 / factor;

      par_pb_calibration_maintenance_timer.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_maintenance_timer_local.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_interval.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_interval_local.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_rest_life_time.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_rest_life_time_local.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_warning_limit_2.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_warning_limit_2_local.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_warning_limit_1.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
      par_pb_calibration_warning_limit_1_local.VARIABLE_STATUS = par_pb_calibration_maintenance_timer_unit.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_pb_calibration_rest_life_time
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_rest_life_time_local = par_pb_calibration_rest_life_time / factor;
      par_pb_calibration_rest_life_time_local.VARIABLE_STATUS = par_pb_calibration_rest_life_time.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_calibration_rest_life_time_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_rest_life_time = par_pb_calibration_rest_life_time_local * factor;
      par_pb_calibration_rest_life_time.VARIABLE_STATUS = par_pb_calibration_rest_life_time_local.VARIABLE_STATUS;
   }
}



METHOD method_post_read_par_pb_calibration_warning_limit_1
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_warning_limit_1_local = par_pb_calibration_warning_limit_1 / factor;
      par_pb_calibration_warning_limit_1_local.VARIABLE_STATUS = par_pb_calibration_warning_limit_1.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_calibration_warning_limit_1_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_warning_limit_1 = par_pb_calibration_warning_limit_1_local * factor;
      par_pb_calibration_warning_limit_1.VARIABLE_STATUS = par_pb_calibration_warning_limit_1_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_pb_calibration_warning_limit_2
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_warning_limit_2_local = par_pb_calibration_warning_limit_2 / factor;
      par_pb_calibration_warning_limit_2_local.VARIABLE_STATUS = par_pb_calibration_warning_limit_2.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_calibration_warning_limit_2_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_warning_limit_2 = par_pb_calibration_warning_limit_2_local * factor;
      par_pb_calibration_warning_limit_2.VARIABLE_STATUS = par_pb_calibration_warning_limit_2_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_pb_calibration_interval
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_interval_local = par_pb_calibration_interval / factor;
      par_pb_calibration_interval_local.VARIABLE_STATUS = par_pb_calibration_interval.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_pb_calibration_interval_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_pb_calibration_maintenance_timer_unit)
      par_pb_calibration_interval = par_pb_calibration_interval_local * factor;
      par_pb_calibration_interval.VARIABLE_STATUS = par_pb_calibration_interval_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_tb_sensor_rest_life_time
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_rest_life_time_local = par_tb_sensor_rest_life_time / factor;
      par_tb_sensor_rest_life_time_local.VARIABLE_STATUS = par_tb_sensor_rest_life_time.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_tb_sensor_rest_life_time_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_rest_life_time = par_tb_sensor_rest_life_time_local * factor;
      par_tb_sensor_rest_life_time.VARIABLE_STATUS = par_tb_sensor_rest_life_time_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_tb_sensor_warning_limit_1
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_warning_limit_1_local = par_tb_sensor_warning_limit_1 / factor;
      par_tb_sensor_warning_limit_1_local.VARIABLE_STATUS = par_tb_sensor_warning_limit_1.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_tb_sensor_warning_limit_1_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_warning_limit_1 = par_tb_sensor_warning_limit_1_local * factor;
      par_tb_sensor_warning_limit_1.VARIABLE_STATUS = par_tb_sensor_warning_limit_1_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_tb_sensor_warning_limit_2
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_warning_limit_2_local = par_tb_sensor_warning_limit_2 / factor;
      par_tb_sensor_warning_limit_2_local.VARIABLE_STATUS = par_tb_sensor_warning_limit_2.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_tb_sensor_warning_limit_2_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_warning_limit_2 = par_tb_sensor_warning_limit_2_local * factor;
      par_tb_sensor_warning_limit_2.VARIABLE_STATUS = par_tb_sensor_warning_limit_2_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_tb_sensor_expected_lifetime
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_expected_lifetime_local = par_tb_sensor_expected_lifetime / factor;
      par_tb_sensor_expected_lifetime_local.VARIABLE_STATUS = par_tb_sensor_expected_lifetime.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_tb_sensor_expected_lifetime_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_expected_lifetime = par_tb_sensor_expected_lifetime_local * factor;
      par_tb_sensor_expected_lifetime.VARIABLE_STATUS = par_tb_sensor_expected_lifetime_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_tb_sensor_operating_hours
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_operating_hours_local = par_tb_sensor_operating_hours / factor;
      par_tb_sensor_operating_hours_local.VARIABLE_STATUS = par_tb_sensor_operating_hours.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_tb_sensor_operating_hours_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_operating_hours = par_tb_sensor_operating_hours_local * factor;
      par_tb_sensor_operating_hours.VARIABLE_STATUS = par_tb_sensor_operating_hours_local.VARIABLE_STATUS;
   }
}

METHOD method_pre_edit_par_tb_sensor_operating_hours_unit
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_operating_hours_local = par_tb_sensor_operating_hours / factor;
      par_tb_sensor_expected_lifetime_local = par_tb_sensor_expected_lifetime / factor;
      par_tb_sensor_rest_life_time_local = par_tb_sensor_rest_life_time / factor;
      par_tb_sensor_warning_limit_1_local = par_tb_sensor_warning_limit_1 / factor;
      par_tb_sensor_warning_limit_2_local = par_tb_sensor_warning_limit_2 / factor;
   }
}

METHOD method_post_edit_par_tb_sensor_operating_hours_unit
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_sensor_operating_hours_unit)
      par_tb_sensor_operating_hours_local = par_tb_sensor_operating_hours / factor;
      par_tb_sensor_expected_lifetime_local = par_tb_sensor_expected_lifetime / factor;
      par_tb_sensor_rest_life_time_local = par_tb_sensor_rest_life_time / factor;
      par_tb_sensor_warning_limit_1_local = par_tb_sensor_warning_limit_1 / factor;
      par_tb_sensor_warning_limit_2_local = par_tb_sensor_warning_limit_2 / factor;

      par_tb_sensor_operating_hours.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_operating_hours_local.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_expected_lifetime.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_expected_lifetime_local.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_rest_life_time.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_rest_life_time_local.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_warning_limit_1.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_warning_limit_1_local.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_warning_limit_2.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
      par_tb_sensor_warning_limit_2_local.VARIABLE_STATUS = par_tb_sensor_operating_hours_unit.VARIABLE_STATUS;
   }
}


METHOD method_post_read_par_tb_service_maintenance_timer
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_maintenance_timer_local = par_tb_service_maintenance_timer / factor;
      par_tb_service_maintenance_timer_local.VARIABLE_STATUS = par_tb_service_maintenance_timer.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_tb_service_maintenance_timer_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_maintenance_timer = par_tb_service_maintenance_timer_local * factor;
      par_tb_service_maintenance_timer.VARIABLE_STATUS = par_tb_service_maintenance_timer_local.VARIABLE_STATUS;
   }
}

METHOD method_pre_edit_par_tb_service_maintenance_timer_unit
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_maintenance_timer_local = par_tb_service_maintenance_timer / factor;
      par_tb_service_interval_local = par_tb_service_interval / factor;
      par_tb_service_rest_life_time_local = par_tb_service_rest_life_time / factor;
      par_tb_service_warning_limit_1_local = par_tb_service_warning_limit_1 / factor;
      par_tb_service_warning_limit_2_local = par_tb_service_warning_limit_2 / factor;
      }
}

METHOD method_post_edit_par_tb_service_maintenance_timer_unit
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_maintenance_timer_local = par_tb_service_maintenance_timer / factor;
      par_tb_service_interval_local = par_tb_service_interval / factor;
      par_tb_service_rest_life_time_local = par_tb_service_rest_life_time / factor;
      par_tb_service_warning_limit_1_local = par_tb_service_warning_limit_1 / factor;
      par_tb_service_warning_limit_2_local = par_tb_service_warning_limit_2 / factor;

      par_tb_service_maintenance_timer.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_maintenance_timer_local.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_interval.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_interval_local.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_rest_life_time.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_rest_life_time_local.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_warning_limit_1.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_warning_limit_1_local.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_warning_limit_2.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;
      par_tb_service_warning_limit_2_local.VARIABLE_STATUS = par_tb_service_maintenance_timer_unit.VARIABLE_STATUS;

   }
}
METHOD method_post_read_par_tb_service_rest_life_time
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_rest_life_time_local = par_tb_service_rest_life_time / factor;
      par_tb_service_rest_life_time_local.VARIABLE_STATUS = par_tb_service_rest_life_time.VARIABLE_STATUS;
   }
}

METHOD method_post_edit_par_tb_service_rest_life_time_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_rest_life_time = par_tb_service_rest_life_time_local * factor;
      par_tb_service_rest_life_time.VARIABLE_STATUS = par_tb_service_rest_life_time_local.VARIABLE_STATUS;
   }
}

METHOD method_post_read_par_tb_service_warning_limit_1
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_warning_limit_1_local = par_tb_service_warning_limit_1 / factor;
      par_tb_service_warning_limit_1_local.VARIABLE_STATUS = par_tb_service_warning_limit_1.VARIABLE_STATUS;
      }
}

METHOD method_post_edit_par_tb_service_warning_limit_1_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_warning_limit_1 = par_tb_service_warning_limit_1_local * factor;
      par_tb_service_warning_limit_1.VARIABLE_STATUS = par_tb_service_warning_limit_1_local.VARIABLE_STATUS;
      }
}

METHOD method_post_read_par_tb_service_warning_limit_2
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_warning_limit_2_local = par_tb_service_warning_limit_2 / factor;
      par_tb_service_warning_limit_2_local.VARIABLE_STATUS = par_tb_service_warning_limit_2.VARIABLE_STATUS;
      }
}

METHOD method_post_edit_par_tb_service_warning_limit_2_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_warning_limit_2 = par_tb_service_warning_limit_2_local * factor;
      par_tb_service_warning_limit_2.VARIABLE_STATUS = par_tb_service_warning_limit_2_local.VARIABLE_STATUS;
      }
}

METHOD method_post_read_par_tb_service_interval
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_interval_local = par_tb_service_interval / factor;
      par_tb_service_interval_local.VARIABLE_STATUS = par_tb_service_interval.VARIABLE_STATUS;
      }
}

METHOD method_post_edit_par_tb_service_interval_local
{
   DEFINITION
   {
      TIME_UNITS_CONVERSION_FACTOR(par_tb_service_maintenance_timer_unit)
      par_tb_service_interval = par_tb_service_interval_local * factor;
      par_tb_service_interval.VARIABLE_STATUS = par_tb_service_interval_local.VARIABLE_STATUS;
      }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
