/*
$Id: Trend/trend.inc 1.9 2007/10/26 13:52:39EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/dd_library/common/lr_food3_hart_device_descriptions_common_library.pj $   $Locker:  $
*/

#ifndef TREND_INC
#define TREND_INC
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
		 Library file to display a trend.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

       The user calls the method "method_menu_trend" or this method can be added
       to a menu.

       The "trendopt.dd" file must be created.
       Use the template with the name "trendopt.tpl.dd".

       Saving and showing of trends can be supported by also adding "showtrend.inc".

   Defines --------------------------------------------------------------------*/

/* Include Files --------------------------------------------------------------*/
#include "trendopt.dd"

/* Collections ----------------------------------------------------------------*/

/* Relations ------------------------------------------------------------------*/

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU OnlineDialog_trend
{
   LABEL  TREND_DIALOG_LABEL;
   STYLE_ONLINE_DIALOG
   ITEMS
   {
      Page_trend
   }
}

MENU Page_trend
{
   LABEL  TREND_DIALOG_LABEL;
   HELP   TREND_DIALOG_HELP;
   STYLE_PAGE
   ITEMS
   {
      #ifdef TREND_MULTIPLE_GROUPS
      Group_trend_parameters_1,
      Group_trend_parameters_2
      #else
      Group_trend_parameters
      #endif
      #ifndef HELP_SUPPORT
         , chart_trend
      #endif
      #ifdef SHOWTREND_INC
         , Group_save_trend
      #endif
   }
}

#ifdef TREND_MULTIPLE_GROUPS
   MENU Group_trend_parameters_1
   {
      LABEL TREND_GROUP_1_LABEL;
      #ifdef HELP_SUPPORT
         HELP  TREND_DIALOG_HELP;
      #endif
      STYLE_GROUP
      ITEMS
      {
         TREND_LEVEL_VALUE(READ_ONLY)
      }
   }
   MENU Group_trend_parameters_2
   {
      LABEL TREND_GROUP_2_LABEL;
      #ifdef HELP_SUPPORT
         HELP  TREND_DIALOG_HELP;
      #endif
      STYLE_GROUP
      ITEMS
      {
         TREND_DISTANCE_VALUE(READ_ONLY)
      }
   }
#else
   MENU Group_trend_parameters
   {
      #ifdef HELP_SUPPORT
         LABEL TREND_DIALOG_LABEL;
         HELP  TREND_DIALOG_HELP;
      #endif
      STYLE_GROUP
      ITEMS
      {
         TREND_LEVEL_VALUE(READ_ONLY),
         TREND_DISTANCE_VALUE(READ_ONLY)
      }
   }
#endif


/* Visual component Definitions -----------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Displays graph area, content is referenced from here
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifndef HELP_SUPPORT
   CHART chart_trend
   {
      LABEL  TREND_DIALOG_LABEL;
      TYPE   STRIP;
      CYCLE_TIME 1000 ;  //milliseconds
      MEMBERS
      {
         SOURCE_TREND_LEVEL, source_trend_level;
      }
      WIDTH  LARGE;
      HEIGHT LARGE;
   }

   SOURCE source_trend_level
   {
      Y_AXIS axis_trend_y_level;
      MEMBERS
      {
         LEVEL, TREND_LEVEL_VALUE;
      }
      #ifdef SHOWTREND_INC
         INIT_ACTIONS
         {
            method_trend_save_init
         }
         REFRESH_ACTIONS
         {
            method_trend_save_save_data
         }
         EXIT_ACTIONS
         {
            method_trend_save_stop
         }
      #endif
   }

   AXIS axis_trend_y_level
   {
       LABEL         TREND_Y_AXIS_LABEL;
       MIN_VALUE     TREND_LEVEL_LRV;
       MAX_VALUE     TREND_LEVEL_URV;
       CONSTANT_UNIT TREND_LEVEL_UNITS(TREND_LEVEL_UNITS);
   }
#endif

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_menu_trend
{
   LABEL  TREND_DIALOG_LABEL;
   HELP   TREND_DIALOG_HELP;
   DEFINITION
   {
      long result;

      MenuDisplay(OnlineDialog_trend, CLOSE_BUTTON_LABEL, result);

      #ifdef SHOWTREND_INC
         method_trend_save_stop();
      #endif
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/




