 /*
$Id: Breakpoints/volumelinearization32.inc 1.10 2007/08/28 17:15:49EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/dd_library/common/lr_food3_hart_device_descriptions_common_library.pj $   $Locker:  $
*/

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
		 Volume Linearization dialog for a device that uses a 32 point breakpoint table.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

       The user calls the method "method_menu_manual_linearization" or this
       method can be added to a menu.

       The "volume_linearizationopt.dd" file must be created.
       Use the template with the name "volumelinearizationopt.tpl.dd".

   Defines --------------------------------------------------------------------*/
#define LINEARIZATION_NUMBER_BREAKPOINTS  32


/* Include Files --------------------------------------------------------------*/
#include "volumelinearizationopt.dd"

/* Defines --------------------------------------------------------------------*/
/* The following conditional must be after the option file is included */
#ifdef LINEARIZATION_HIDE_VOLUME_UNITS
   #define LINEARIZATION_VOLUME_UNITS_VISIBILITY (HIDDEN)
#else
   #define LINEARIZATION_VOLUME_UNITS_VISIBILITY
#endif

/* Collections ----------------------------------------------------------------*/

/* Relations ------------------------------------------------------------------*/
ARRAY array_level_linearization
{
    NUMBER_OF_ELEMENTS LINEARIZATION_NUMBER_BREAKPOINTS;
    TYPE               var_level_linearization;
}

ARRAY array_volume_linearization
{
    NUMBER_OF_ELEMENTS LINEARIZATION_NUMBER_BREAKPOINTS;
    TYPE               var_volume_linearization;
}

UNIT volume_linearization_units_level
{
   linearization_level_unit
   :
   linearization_maximum_level,
   array_level_linearization[0],
   array_level_linearization[1],
   array_level_linearization[2],
   array_level_linearization[3],
   array_level_linearization[4],
   array_level_linearization[5],
   array_level_linearization[6],
   array_level_linearization[7],
   array_level_linearization[8],
   array_level_linearization[9],
   array_level_linearization[10],
   array_level_linearization[11],
   array_level_linearization[12],
   array_level_linearization[13],
   array_level_linearization[14],
   array_level_linearization[15],
   array_level_linearization[16],
   array_level_linearization[17],
   array_level_linearization[18],
   array_level_linearization[19],
   array_level_linearization[20],
   array_level_linearization[21],
   array_level_linearization[22],
   array_level_linearization[23],
   array_level_linearization[24],
   array_level_linearization[25],
   array_level_linearization[26],
   array_level_linearization[27],
   array_level_linearization[28],
   array_level_linearization[29],
   array_level_linearization[30],
   array_level_linearization[31]
}

UNIT volume_linearization_units_volume
{
   linearization_volume_unit
   :
   linearization_maximum_volume,
   array_volume_linearization[0],
   array_volume_linearization[1],
   array_volume_linearization[2],
   array_volume_linearization[3],
   array_volume_linearization[4],
   array_volume_linearization[5],
   array_volume_linearization[6],
   array_volume_linearization[7],
   array_volume_linearization[8],
   array_volume_linearization[9],
   array_volume_linearization[10],
   array_volume_linearization[11],
   array_volume_linearization[12],
   array_volume_linearization[13],
   array_volume_linearization[14],
   array_volume_linearization[15],
   array_volume_linearization[16],
   array_volume_linearization[17],
   array_volume_linearization[18],
   array_volume_linearization[19],
   array_volume_linearization[20],
   array_volume_linearization[21],
   array_volume_linearization[22],
   array_volume_linearization[23],
   array_volume_linearization[24],
   array_volume_linearization[25],
   array_volume_linearization[26],
   array_volume_linearization[27],
   array_volume_linearization[28],
   array_volume_linearization[29],
   array_volume_linearization[30],
   array_volume_linearization[31]
}

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_level_linearization
{
    LABEL LINEARIZATION_LEVEL_POINTS_LABEL;
    HELP  LINEARIZATION_LEVEL_POINTS_HELP;
    CLASS LOCAL;
    TYPE  FLOAT
    {
        EDIT_FORMAT         LINEARIZATION_POINTS_FORMAT;
        DISPLAY_FORMAT      LINEARIZATION_POINTS_FORMAT;
        DEFAULT_VALUE       0.0;
        MAX_VALUE           LINEARIZATION_POINTS_MAX_LEVEL;
        MIN_VALUE           0;
    }
    HANDLING READ & WRITE;
}

VARIABLE var_volume_linearization
{
    LABEL LINEARIZATION_VOLUME_POINTS_LABEL;
    HELP  LINEARIZATION_VOLUME_POINTS_HELP;
    CLASS LOCAL;
    TYPE  FLOAT
    {
        EDIT_FORMAT         LINEARIZATION_POINTS_FORMAT;
        DISPLAY_FORMAT      LINEARIZATION_POINTS_FORMAT;
        DEFAULT_VALUE       0.0;
        MAX_VALUE           MAX_FLOAT;
        MIN_VALUE           0;
    }
    HANDLING READ & WRITE;
}

VARIABLE var_points_used_linearization
{
   CLASS LOCAL;
   TYPE  UNSIGNED_INTEGER (1)
   {
      DEFAULT_VALUE LINEARIZATION_NUMBER_BREAKPOINTS;
   }
}

linearization_level_unit     LIKE VARIABLE LINEARIZATION_LEVEL_UNIT
{
   REDEFINE LABEL LINEARIZATION_LEVEL_UNITS_LABEL;
}
linearization_volume_unit    LIKE VARIABLE LINEARIZATION_VOLUME_UNIT
{
   REDEFINE LABEL LINEARIZATION_VOLUME_UNITS_LABEL;
}
linearization_maximum_level  LIKE VARIABLE LINEARIZATION_MAXIMUM_LEVEL  {}
linearization_maximum_volume LIKE VARIABLE LINEARIZATION_MAXIMUM_VOLUME {}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU offlineDialog_manual_linearization
{
   LABEL LINEARIZATION_LABEL;
   HELP  LINEARIZATION_HELP;
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      Page_linearization_graph,
      Page_linearization_breakpoints_1_8,
      Page_linearization_breakpoints_9_16,
      Page_linearization_breakpoints_17_24,
      Page_linearization_breakpoints_25_32
   }
}
MENU Page_linearization_graph
{
   LABEL LINEARIZATION_LABEL;
   HELP  LINEARIZATION_HELP;
   STYLE_PAGE
   ITEMS
   {
      #ifndef HELP_SUPPORT
         graph_linearization,
      #endif
      ROWBREAK,
      Group_linearization_graph
   }
}
MENU Group_linearization_graph
{
   #ifdef HELP_SUPPORT
      LABEL [Units_label];
   #endif
   STYLE_GROUP
   ITEMS
   {
      linearization_level_unit,
      COLUMNBREAK,
      #if LINEARIZATION_VOLUME_UNITS_VISIBLE
         linearization_volume_unit
      #endif 
   }
}

MENU Page_linearization_breakpoints_1_8
{
   LABEL LINEARIZATION_LEVEL_VOLUME_LABEL + " 1 - 8";
   HELP  LINEARIZATION_LEVEL_VOLUME_HELP;
   STYLE_PAGE
   ITEMS
   {
      MENU_LABEL(LINEARIZATION_LEVEL_LABEL)
      array_level_linearization[0],
      array_level_linearization[1],
      array_level_linearization[2],
      array_level_linearization[3],
      array_level_linearization[4],
      array_level_linearization[5],
      array_level_linearization[6],
      array_level_linearization[7],
      COLUMNBREAK,
      MENU_LABEL(LINEARIZATION_VOLUME_LABEL)
      array_volume_linearization[0],
      array_volume_linearization[1],
      array_volume_linearization[2],
      array_volume_linearization[3],
      array_volume_linearization[4],
      array_volume_linearization[5],
      array_volume_linearization[6],
      array_volume_linearization[7]
   }
}

MENU Page_linearization_breakpoints_9_16
{
   LABEL LINEARIZATION_LEVEL_VOLUME_LABEL + " 9 - 16";
   HELP  LINEARIZATION_LEVEL_VOLUME_HELP;
   STYLE_PAGE
   ITEMS
   {
      MENU_LABEL(LINEARIZATION_LEVEL_LABEL)
      array_level_linearization[8],
      array_level_linearization[9],
      array_level_linearization[10],
      array_level_linearization[11],
      array_level_linearization[12],
      array_level_linearization[13],
      array_level_linearization[14],
      array_level_linearization[15],
      COLUMNBREAK,
      MENU_LABEL(LINEARIZATION_VOLUME_LABEL)
      array_volume_linearization[8],
      array_volume_linearization[9],
      array_volume_linearization[10],
      array_volume_linearization[11],
      array_volume_linearization[12],
      array_volume_linearization[13],
      array_volume_linearization[14],
      array_volume_linearization[15]
   }
}

MENU Page_linearization_breakpoints_17_24
{
   LABEL LINEARIZATION_LEVEL_VOLUME_LABEL + " 17 - 24";
   HELP  LINEARIZATION_LEVEL_VOLUME_HELP;
   STYLE_PAGE
   ITEMS
   {
      MENU_LABEL(LINEARIZATION_LEVEL_LABEL)
      array_level_linearization[16],
      array_level_linearization[17],
      array_level_linearization[18],
      array_level_linearization[19],
      array_level_linearization[20],
      array_level_linearization[21],
      array_level_linearization[22],
      array_level_linearization[23],
      COLUMNBREAK,
      MENU_LABEL(LINEARIZATION_VOLUME_LABEL)
      array_volume_linearization[16],
      array_volume_linearization[17],
      array_volume_linearization[18],
      array_volume_linearization[19],
      array_volume_linearization[20],
      array_volume_linearization[21],
      array_volume_linearization[22],
      array_volume_linearization[23]
   }
}

MENU Page_linearization_breakpoints_25_32
{
   LABEL LINEARIZATION_LEVEL_VOLUME_LABEL + " 25 - 32";
   HELP  LINEARIZATION_LEVEL_VOLUME_HELP;
   STYLE_PAGE
   ITEMS
   {
      MENU_LABEL(LINEARIZATION_LEVEL_LABEL)
      array_level_linearization[24],
      array_level_linearization[25],
      array_level_linearization[26],
      array_level_linearization[27],
      array_level_linearization[28],
      array_level_linearization[29],
      array_level_linearization[30],
      array_level_linearization[31],
      COLUMNBREAK,
      MENU_LABEL(LINEARIZATION_VOLUME_LABEL)
      array_volume_linearization[24],
      array_volume_linearization[25],
      array_volume_linearization[26],
      array_volume_linearization[27],
      array_volume_linearization[28],
      array_volume_linearization[29],
      array_volume_linearization[30],
      array_volume_linearization[31]
   }
}

/* Visual component Definitions -----------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Displays graph area, content is referenced from here
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifndef HELP_SUPPORT
GRAPH graph_linearization
{
   HEIGHT X_LARGE;
   WIDTH  LARGE;
   X_AXIS x_axis_level_linearization;
   MEMBERS
   {
      WAVEFORM1, waveform_linearization;
   }
}

WAVEFORM waveform_linearization
{
   Y_AXIS     y_axis_volume_linearization;
   LINE_COLOR 0x000000;   // black
   TYPE  XY
   {
      NUMBER_OF_POINTS var_points_used_linearization;
      X_VALUES
      {
          array_level_linearization
      }
      Y_VALUES
      {
          array_volume_linearization
      }
   }
   REFRESH_ACTIONS
   {
      method_linearization_count_used_points
   }
}

AXIS x_axis_level_linearization
{
   LABEL     LINEARIZATION_LEVEL_AXIS_LABEL;
   MIN_VALUE 0;
   MAX_VALUE
      IF (array_level_linearization[var_points_used_linearization - 1] > linearization_maximum_level)
         {
         array_level_linearization[var_points_used_linearization - 1];
         }
      ELSE
         {
         linearization_maximum_level;
         }
   CONSTANT_UNIT linearization_level_unit(linearization_level_unit);
}

AXIS y_axis_volume_linearization
{
   LABEL      LINEARIZATION_VOLUME_AXIS_LABEL;
   MIN_VALUE  0;
   MAX_VALUE
      IF (array_volume_linearization[var_points_used_linearization - 1] > linearization_maximum_volume)
         {
         array_volume_linearization[var_points_used_linearization - 1];
         }
      ELSE
         {
         linearization_maximum_volume;
         }
   CONSTANT_UNIT linearization_volume_unit(linearization_volume_unit);
}
#endif

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_menu_manual_linearization
{
   LABEL  LINEARIZATION_LABEL;
   HELP   LINEARIZATION_HELP;
   ACCESS OFFLINE;
   DEFINITION
   {
      long selected;

      method_linearization_get_breakpoints();
      while (1)
         {
         MenuDisplay(offlineDialog_manual_linearization, LINEARIZATION_BUTTONS, selected);
         if(selected == 0)
            {
            method_linearization_set_breakpoints();
            break;
            }
         if(selected == 1)
            {
            method_linearization_clear_values();
            }
         if(selected == 2)
            {
            break;
            }
         }
   }
   VALIDITY  LINEARIZATION_VALIDITY;
}

METHOD method_linearization_count_used_points
{
   DEFINITION
   {
      int  i;

      for (i = LINEARIZATION_NUMBER_BREAKPOINTS - 1; i > 0; i--)
         {
         if ((array_level_linearization[i] != 0.0) || (array_volume_linearization[i] != 0.0))
            {
            break;
            }
         }
      var_points_used_linearization = i + 1;
   }
}

METHOD method_linearization_get_breakpoints
{
   DEFINITION
   {
      int  i;

      linearization_level_unit     = LINEARIZATION_LEVEL_UNIT;
      linearization_volume_unit    = LINEARIZATION_VOLUME_UNIT;
      linearization_maximum_level  = LINEARIZATION_MAXIMUM_LEVEL;
      linearization_maximum_volume = LINEARIZATION_MAXIMUM_VOLUME;

      for (i = 0; i < LINEARIZATION_NUMBER_BREAKPOINTS; i++)
         {
         array_level_linearization[i]   = LINEARIZATION_LEVEL_ARRAY[i];
         array_volume_linearization[i]  = LINEARIZATION_VOLUME_ARRAY[i];
         }
   }
}

METHOD method_linearization_set_breakpoints
{
   DEFINITION
   {
      int  i;

      LINEARIZATION_LEVEL_UNIT  = linearization_level_unit;
      LINEARIZATION_VOLUME_UNIT = linearization_volume_unit;

      for (i = 0; i < LINEARIZATION_NUMBER_BREAKPOINTS; i++)
         {
         LINEARIZATION_LEVEL_ARRAY[i]   = array_level_linearization[i];
         LINEARIZATION_VOLUME_ARRAY[i]  = array_volume_linearization[i];
         }
   }
}

METHOD method_linearization_clear_values
{
   LABEL LINEARIZATION_CLEAR_VALUES_LABEL;
   DEFINITION
   {
      int i;

      for (i = 0; i < LINEARIZATION_NUMBER_BREAKPOINTS; i++)
         {
         array_level_linearization[i] = 0;
         array_volume_linearization[i] = 0;
         }
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
